new;
library tsm,optmum,pgraph;
TSMset;

declare external alpha;
declare external beta;
declare external delta;
declare external gamma_;

proc f(x);
  local y;
  y = 1./(1+alpha*(x^beta)+delta*(x^gamma_));
  retp(y);
endp;

proc g(x);
  local z,y;
  z = f(x);
  y = -ln(z)./x;
  retp(y);
endp;

x = seqa(1/12,1/12,100);

alpha = 0.025;
beta = 1.5;
delta = 0;
gamma_ = -1;
P1 = f(x);
R1 = g(x);

alpha = 0.035;
beta = 1.35;
delta = 0.005;
gamma_ = -0.05;
P2 = f(x);
R2 = g(x);

c = meanc(P1-P2);
P3 = P2 + c;
R3 = -ln(P3)./x;


graphset;
  begwind;
  window2(1,2,0,0.5);

  setwind(1);

    _pdate = ""; _ptitlht = 2.5; _pnum = 0; _paxes = 0;
    title("Un exemple de reparametrisation");
    draw;

  setwind(2);

    graphset;
    _pnum = 2; _pnumht = 0.25; _paxht = 0.25; _ptitlht = 0.40;
    _plegstr = "f]1[\0f]2[\0f]3["; _plegctl = {2 8 1.75 1};
    title("f(x)");
    _pltype = 6|1|2; _plwidth = 0|0|10;
    xy(x,P1~P2~P3);

  setwind(3);
    title("g(x)");
    _plegstr = "g]1[\0g]2[\0g]3["; _plegctl = {2 8 4.75 1};
    scale(0|9,0|0.08);
    xy(x,R1~R2~R3);

    graphprt("-c=1 -cf=courbure.eps -w=5");
  endwind;


