new;
library spt,pgraph,tsm,optmum;
TSMset;

maturite = loadd(spt_data_path $+ "mat_frf");
y = loadd(spt_data_path $+ "frf");   
Dates = y[.,1];
Pc = trimr(y',1,0)';

Pc = selif(Pc, Dates .== 19940215); Pc = Pc';
o150294 = CouponZero_to_Obligation(Pc,maturite);

yield = -ln(Pc)./maturite;
Nobs = rows(yield);

Poids = ones(16,1); Poids[1 2 3] = 50|25|10;

tau_star = 1~2~4;

c1 = DebandtLesne(o150294,tau_star[1],Poids);
c2 = DebandtLesne(o150294,tau_star[2],Poids);
c4 = DebandtLesne(o150294,tau_star[3],Poids);

coefficients = c1~c2~c4;

tau = seqa(1/10,1/10,300);

CouponZero = DebandtLesne_CouponZero(coefficients,tau_star,tau);
R = DebandtLesne_TauxZero(coefficients,tau_star,tau);

graphset;
  _pdate = ""; _pnum = 2;
  fonts("simplex simgrma");
  title("Estimation de la courbe des taux zero du 15/02/94"\
        "\Lmodele de De Bandt et Lesne");
  _psym = maturite~yield~ones(Nobs,1).*(14~8~2~1~1);
  xlabel("maturite \202t\201 (en annees)");
  ylabel("Taux zero R]t[(\202t\201)");
  xtics(0,10,1,12);
  ytics(0.053,0.062,0.001,0);
  _plwidth = 0|0|10;
  _plegstr = "\202t\201[*] = 1\0\202t\201[*] = 2\0\202t\201[*] = 4";
  _plegctl = {2 5 6.25 1.1};
  graphprt("-c=1 -cf=debandt1.eps -w=5");
  xy(tau,R);


