new;
library spt,pgraph,tsm,optmum;
TSMset;

maturite = loadd(spt_data_path $+ "mat_frf");
y = loadd(spt_data_path $+ "frf");   
Dates = y[.,1];
Pc = trimr(y',1,0)';

Pc = selif(Pc, Dates .== 19940215); Pc = Pc';
o150294 = CouponZero_to_Obligation(Pc,maturite);

yield = -ln(Pc)./maturite;
Nobs = rows(yield);

Poids = ones(16,1);
Poids[1 2 3] = 50|25|10;

tau = seqa(1/10,1/10,300);

tau_star = 1;
c = DebandtLesne2(o150294,tau_star,Poids);
R1 = DebandtLesne2_TauxZero(c,tau_star,tau);

tau_star = 1|5;
c = DebandtLesne2(o150294,tau_star,Poids);
R2 = DebandtLesne2_TauxZero(c,tau_star,tau);

tau_star = 1|3|8;
c = DebandtLesne2(o150294,tau_star,Poids);
R3 = DebandtLesne2_TauxZero(c,tau_star,tau);

graphset;
  _pdate = ""; _pnum = 2;
  fonts("simplex simgrma");
  title("Estimation de la courbe des taux zero du 15/02/94"\
        "\Lmodele generalise de De Bandt et Lesne");
  _psym = maturite~yield~ones(Nobs,1).*(14~8~2~1~1);
  xtics(0,10,1,12);
  ytics(0.053,0.062,0.001,0);
  xlabel("maturite \202t\201 (en annees)");
  ylabel("Taux zero R]t[(\202t\201)");
  _plwidth = 0|0|10;
  _plegstr = "\202t\201[*] = 1\000\202t\201[*] = (1,5)[T]"\
             "\000\202t\201[*] = (1,3,8)[T]";
  _plegctl = {2 5 6.15 1.1};
  graphprt("-c=1 -cf=debandt2.eps -w=5");
  xy(tau,R1~R2~R3);


