new;
library spt,pgraph,optmum;
SPTset;

maturite = loadd(spt_data_path $+ "mat_frf");
y = loadd(spt_data_path $+ "frf");   
Dates = y[.,1];
Pc = trimr(y',1,0)';

Pc = selif(Pc, Dates .== 19940215); Pc = Pc';
o150294 = CouponZero_to_Obligation(Pc,maturite);

yield = -ln(Pc)./maturite;
Nobs = rows(yield);

tau = seqa(1/10,1/10,300);

c = NelsonSiegel_(o150294,1,0,0);
TauxZero = NelsonSiegel_TauxZero(c,tau);

graphset;
  _pdate = ""; _pnum = 2;
  fonts("simplex simgrma");
  title("Estimation de la courbe des taux zero du 15/02/94"\
        "\Lmodele de Nelson et Siegel");
  _psym = maturite~yield~ones(Nobs,1).*(14~8~2~1~1);
  xlabel("maturite \202t\201 (en annees)");
  ylabel("Taux zero R]t[(\202t\201)");
  xtics(0,15,1,12);
  ytics(0.053,0.062,0.001,0);
  graphprt("-c=1 -cf=nelson2.eps -w=5");
  xy(tau,TauxZero);



