new;
library spt,pgraph;
graphset;
SPTset;

maturite = loadd(spt_data_path $+ "mat_frf");
y = loadd(spt_data_path $+ "frf");   
Dates = y[.,1];
Pc = trimr(y',1,0)';

Pc = selif(Pc, Dates .== 19940215); 
R = -ln(Pc')./maturite;
Nobs = rows(R);

tau = seqa(1/12,1/12,30*12);

R1 = fspline(csspline(maturite,R,1,0),tau);
R2 = fspline(csspline(maturite,R,1,1),tau);
R3 = fspline(csspline(maturite,R,1,0.15),tau);

graphset;
  fonts("simplex simgrma");
  title("Estimation smoothing spline de la courbe des taux zero du \L15/02/94");
  _pdate = ""; _pnum = 2; _pltype = 6|1|3;
  _psym = maturite~R~ones(Nobs,1).*(14~6~2~1~1);
  xlabel("maturite \202t\201 (en annees)");
  ylabel("Taux zero R]t[(\202t\201)");
  xtics(0,30,5,5);
  _plegstr = "Interpolation\0Regression lineaire\0Approximation";
  _plegctl = {2 6 5 2};
  graphprt("-c=1 -cf=spline1.eps -w=5");
  xy(tau,R2~R1~R3);



