new;
library spt,pgraph,tsm;
graphset;
SPTset;

maturite = loadd(spt_data_path $+ "mat_frf");
y = loadd(spt_data_path $+ "frf");   
Dates = y[.,1];
Pc = trimr(y',1,0)';

Pc = selif(Pc, Dates .== 19940215)'; 
R = -ln(Pc)./maturite;
Nobs = rows(R);

tau = seqa(1/12,1/12,6*12);

P1 = fspline(csspline(maturite,Pc,1,0.75),tau);
R1 = -ln(P1)./tau;

R2 = fspline(csspline(maturite,R,1,0.75),tau);
P2 = exp(-tau.*R2);

graphset;

  begwind;
  window2(2,2,0,0.5);

  setwind(1);

    _pdate = ""; _ptitlht = 2.5; _pnum = 0; _paxes = 0;
    title("Estimation de la structure par terme du 15/02/94");
    draw;

  setwind(2);

    graphset;
    fonts("simplex simgrma");
    _pnum = 2; _pnumht = 0.25; _paxht = 0.25;
    _psym = maturite~Pc~ones(Nobs,1).*(1~10~2~1~1);
    xlabel("maturite \202t\201 (en annees)");
    ylabel("Prix P]t[[c](\202t\201)");
    xtics(0,5,1,12);
    xy(tau,P1);

  setwind(3);
    _psym = maturite~R~ones(Nobs,1).*(14~10~2~1~1);
    ylabel("Taux zero R]t[(\202t\201)");
    xy(tau,R1);

  setwind(5);
    _psym = maturite~Pc~ones(Nobs,1).*(1~10~2~1~1);
    ylabel("Prix P]t[[c](\202t\201)");
    xy(tau,P2);

  setwind(4);
    _psym = maturite~R~ones(Nobs,1).*(14~10~2~1~1);
    ylabel("Taux zero R]t[(\202t\201)");
    xy(tau,R2);

    graphprt("-c=1 -cf=spline2.eps -w=5");

  endwind;

