new;
library spt,pgraph;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates_ = NS_frf[.,1];
coefficients = NS_frf[.,2 3 4 5];

tau = seqa(1/12,6/12,2*6);
tau = tau|seqa(6,3,9);
R = NelsonSiegel_TauxZero(coefficients',tau)';

data = Dates_~R;
data = calendrier_31jpm(data,0,0);
data = Interpolation_Donnees(data);

dates = data[.,1];
data = trimr(data',1,0)';
Nobs = rows(data);

d = seqa(1,1,Nobs);

graphset;
  _pdate = ""; _pnum = {2,0,2}; _paxht = 0.20; _pnumht = 0.17;
  title("Evolution de la courbe des taux (France)");
  xlabel("maturite (annees)");
  ylabel("   1996   1995   1994  ");
  xtics(0,30,5,5);
  ytics(1,rows(d),372,0);
  graphprt("-c=1 -cf=sptfrf1.eps -w=5");
  surface(tau',d,data);








