new;
library spt,pgraph,tsm;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates_ = NS_frf[.,1];
coefficients = NS_frf[.,2 3 4 5];

Rinf = NS_frf[.,2];
R0 = Rinf + NS_frf[.,3];

tau = seqa(1/12,1/12,12*10);
R = NelsonSiegel_TauxZero(coefficients',tau)';

data = Dates_~R0~R~Rinf;
data = Interpolation_Donnees( calendrier_31jpm(data,0,0) );

R = data[.,2:122]; Rinf = data[.,123];
s = stdc(R); s_ = stdc(Rinf);

R = packr( R - lag1(R) ); Rinf = packr( Rinf - lag1(Rinf) );
ds = stdc(R); ds_ = stdc(Rinf);

graphset;
  begwind;
  window2(1,2,0,0.75);
  setwind(1);
    _pdate = ""; _ptitlht = 2.0; _pnum = 0; _paxes = 0;
    title("Volatilite des taux zero");
    draw;

  setwind(2);
    graphset;
    fonts("simplex simgrma");
    _pdate = ""; _pnum = 2; _ptitlht = 0.25; _pnumht = 0.25; _paxht = 0.30;
    xlabel("\202t\201");
    ylabel("\202s\34\201R]t[(\202t\201)\202\118\201");
    _pline = 1~1~0~s_~10~s_~1~7~0;
    ytics(0.005,0.011,0.001,10);
    xy(0|tau,s);

  setwind(3);

    ylabel("\202s\34\201R]t[(\202t\201)-R]t-1[(\202t\201)\202\118\201");
    _pline = 1~1~0~ds_~10~ds_~1~7~0;
    ytics(0.0005,0.0014,0.0001,10);
    xy(0|tau,ds);

    graphprt("-c=1 -cf=sptfrf3.eps -w=5");

  endwind;


