new;
library spt,pgraph,tsm,optmum;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;
fichier = spt_data_path $+ "NS_dem"; load NS_dem = ^fichier;

tau = 0~1~5~10;
p_frf = NelsonSiegel_Pente(NS_frf,tau);
p_dem = NelsonSiegel_Pente(NS_dem,tau);

data1 = NS_frf[.,1]~p_frf;
data1 = Interpolation_Donnees(calendrier_31jpm(data1,19940101,19961231));
p_frf = data1[.,2:5];

data2 = NS_dem[.,1]~p_dem;
data2 = Interpolation_Donnees(calendrier_31jpm(data2,19940101,19961231));
p_dem = data2[.,2:5];

Nobs = rows(data1);

p_frf = p_frf*100;
p_dem = p_dem*100;

graphset;
  begwind;
  window2(2,2,0,0.5);

  setwind(1);

    _pdate = ""; _ptitlht = 2.5; _pnum = 0; _paxes = 0;
    title("Pente de la courbe des taux francais");
    draw;

    graphset;
    _pdate = ""; _pnum = 2; _pltype = 6|2; _plwidth = 0|5;
    _pnumht = 0.25; _ptitlht = 0.25; _paxht = 0.25;
    fonts("simplex simgrma");

    let xlab = "1995" "1996" "" " ";
    asclabel(xlab,0);
    xtics(1,Nobs,31*12,12);

  setwind(2);

    title("\202t\201 = 0");
    ytics(-2.5,2.5,1,0);
    bar(seqa(0,1,Nobs),p_frf[.,1]);

  setwind(3);
    title("\202t\201 = 1 an");
    ytics(-0.5,1.0,0.5,0);
    bar(seqa(1,1,Nobs),p_frf[.,2]);

  setwind(4);
    title("\202t\201 = 5 ans");
    ytics(0,0.40,0.1,0);
    bar(seqa(1,1,Nobs),p_frf[.,3]);

  setwind(5);
    title("\202t\201 = 10 ans");
    ytics(0,0.20,0.05,0);
    bar(seqa(1,1,Nobs),p_frf[.,4]);
    graphprt("-c=1 -cf=inflat3.eps -w=5");

  endwind;



graphset;
  begwind;
  window2(2,2,0,0.5);

  setwind(1);

    _pdate = ""; _ptitlht = 2.5; _pnum = 0; _paxes = 0;
    title("Pente de la courbe des taux allemands");
    draw;

    graphset;
    _pdate = ""; _pnum = 2; _pltype = 6|2; _plwidth = 0|5;
    _pnumht = 0.25; _ptitlht = 0.25; _paxht = 0.25;
    fonts("simplex simgrma");

    let xlab = "1995" "1996" "" " ";
    asclabel(xlab,0);
    xtics(1,Nobs,31*12,12);

  setwind(2);

    title("\202t\201 = 0");
    ytics(-2.5,2.5,1,0);
    bar(seqa(0,1,Nobs),p_dem[.,1]);

  setwind(3);
    title("\202t\201 = 1 an");
    ytics(-0.5,1.0,0.5,0);
    bar(seqa(1,1,Nobs),p_dem[.,2]);

  setwind(4);
    title("\202t\201 = 5 ans");
    ytics(0,0.40,0.1,0);
    bar(seqa(1,1,Nobs),p_dem[.,3]);

  setwind(5);
    title("\202t\201 = 10 ans");
    ytics(0,0.20,0.05,0);
    bar(seqa(1,1,Nobs),p_dem[.,4]);
    graphprt("-c=1 -cf=inflat4.eps -w=5");

  endwind;


