new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates = NS_frf[.,1];
{S,P,N1} = NelsonSiegel_SPN(NS_frf,1/100,1);
{S,P,N2} = NelsonSiegel_SPN(NS_frf,1,5);
{S,P,N3} = NelsonSiegel_SPN(NS_frf,5,10);
{S,P,N4} = NelsonSiegel_SPN(NS_frf,0.01,30);

SPN = S~P~N1~N2~N3~N4;
SPN = Interpolation_Donnees(calendrier_31jpm(Dates~SPN,19940101,19961231));

R = NelsonSiegel_TauxZero(NS_frf[.,2:5]',(1/12)|10)';
S3 = R[.,2] - R[.,1];
S3 = Interpolation_Donnees(calendrier_31jpm(Dates~S3,19940101,19961231));

fichier = spt_data_path $+ "taux"; taux = loadd(fichier);

Dates2 = taux[.,1];
S2 = taux[.,3] - taux[.,2];
S2 = Interpolation_Donnees(calendrier_31jpm(Dates2~S2,19940101,19961231));

Nobs = rows(SPN);

graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|3|4; _plwidth = 0|0|5;
  title("Spread de la courbe des taux d'interet");
  let xlab = "1994" "1995" "1996" "1997";
  asclabel(xlab,0);
  xtics(1,Nobs,31*12,12);
  _plegstr = "S]t[\000S]t[(1/12,10)\000LT - Pibor";
  _plegctl = {2 5 1.5 4.85};
  graphprt("-c=1 -cf=spn1.eps -w=5");
  xy(seqa(1,1,Nobs),SPN[.,2]~S3[.,2]~S2[.,2]/100);


  title("Pente de la courbe des taux d'interet");
  _plegstr = "p]t[\000S]t[";
  _plegctl = {2 5 7.25 0.75};
  graphprt("-c=1 -cf=spn2.eps -w=5");
  xy(seqa(1,1,Nobs),SPN[.,3]~SPN[.,2]);


  title("Niveau de la courbe des taux d'interet");
  _pltype = 6|3|4|2; _plwidth = 0|0|5|5;
  _plegstr = "0-1 an\0001-5 ans\0005-10 ans\0000-30 ans";
  _plegctl = {2 5 2.25 0.75};
  graphprt("-c=1 -cf=spn3.eps -w=5");
  xy(seqa(1,1,Nobs),SPN[.,4:7]);

