new;
library spt;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates = NS_frf[.,1];
{S,P,N1} = NelsonSiegel_SPN(NS_frf,1/100,1);

R = NelsonSiegel_TauxZero(NS_frf[.,2:5]',(1/12)|10)';
S2 = R[.,2] - R[.,1];

S = Interpolation_Donnees(calendrier_31jpm(Dates~S~S2,19940101,19961231));

fichier = spt_data_path $+ "taux"; taux = loadd(fichier);

Dates2 = taux[.,1];
S3 = (taux[.,3] - taux[.,2])/100;
S3 = Interpolation_Donnees(calendrier_31jpm(Dates2~S3,19940101,19961231));

Spread = S[.,2 3]~S3[.,2];

output file = spn2.out reset;

y = packr(Spread);
Mcor = corrx(y);

print "Matrice de covariance des spreads (niveau)";
call printfm(Mcor,1,"*.*lf"~8~3});

y = packr(y - lag1(y));
Mcor = corrx(y);

print "Matrice de covariance des spreads (difference)";
call printfm(Mcor,1,"*.*lf"~8~3});

std = zeros(3,2);
std2 = zeros(3,2);

i = 1;
do until i > 3;
  yi = Spread[.,i];
  yi = packr(yi);
  si = stdc(yi);
  std[i,1] = si;
  std2[i,1] = meanc(abs(yi - meanc(yi)));

  yi = packr(yi - lag1(yi));
  yi = packr(yi);
  si = stdc(yi);
  std[i,2] = si;
  std2[i,2] = meanc(abs(yi - meanc(yi)));

  i = i + 1;
endo;

print;
print "Niveau / Difference";
call printfm(std,1,"*.*lf"~10~5});

print;
print "Niveau / Difference";
call printfm(std2,1,"*.*lf"~10~5});

output off;



