new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_dem"; load NS_dem = ^fichier;
Dates_ = NS_dem[.,1];
coefficients = NS_dem[.,2 3 4 5];

tau = seqa(1/12,6/12,2*6);
tau = tau|seqa(6,3,9);
R = NelsonSiegel_TauxZero(coefficients',tau)';

data = Dates_~R;
data = calendrier_31jpm(data,0,0);
data = Interpolation_Donnees(data);

dates = data[.,1];
data = trimr(data',1,0)';
Nobs = rows(data);

d = seqa(1,1,Nobs);

graphset;
  _pdate = ""; _pnum = {2,0,2}; _paxht = 0.20; _pnumht = 0.17;
  title("Evolution de la courbe des taux (Allemagne)");
  xlabel("maturite (annees)");
  ylabel("   1996   1995   1994  ");
  xtics(0,30,5,5);
  ytics(1,rows(d),372,0);
  ztics(0.02,0.10,0.02,2);
  graphprt("-c=1 -cf=sptdem1.eps -w=5");
  surface(tau',d,data);










