new;
library spt,pgraph,optmum,tsm;
SPTset;

fichier = spt_data_path $+ "NS_dem"; load NS_dem = ^fichier;
fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates_dem = NS_dem[.,1];
Dates_frf = NS_frf[.,1];

/* dem */

{S_dem,P_dem,N_dem} = NelsonSiegel_SPN(NS_dem,1/100,1);

mu1 = NS_dem[.,2]; mu2 = NS_dem[.,3]; mu3 = NS_dem[.,4]; tau1 = NS_dem[.,5];

R0_dem = mu1 + mu2;
Rinf_dem = mu1;

dem = Dates_dem~R0_dem~Rinf_dem~S_dem~P_dem~N_dem;

/* FRF */

{S_frf,P_frf,N_frf} = NelsonSiegel_SPN(NS_frf,1/100,1);

mu1 = NS_frf[.,2]; mu2 = NS_frf[.,3]; mu3 = NS_frf[.,4]; tau1 = NS_frf[.,5];

R0_frf = mu1 + mu2;
Rinf_frf = mu1;


dem = Dates_dem~R0_dem~Rinf_dem~S_dem~P_dem~N_dem;
frf = Dates_frf~R0_frf~Rinf_frf~S_frf~P_frf~N_frf;

dem = Interpolation_Donnees(calendrier_31jpm(dem,19940101,19961231));
frf = Interpolation_Donnees(calendrier_31jpm(frf,19940101,19961231));

Nobs = rows(dem);


graphset;
  begwind;
  window2(1,2,0,0.5);

  setwind(1);

    _pdate = ""; _ptitlht = 2.5; _pnum = 0; _paxes = 0;
    title("Comparaison des courbes de taux allemande et francaise");
    draw;

  setwind(2);

    graphset;
    _pdate = ""; _pnum = 2; _pltype = 6|2; _plwidth = 0|5;
    _pnumht = 0.25; _ptitlht = 0.25; _paxht = 0.25;
    let xlab = "1994" "1995" "1996" "1997";
    asclabel(xlab,0);
    xtics(1,Nobs,31*12,12);
    fonts("simplex simgrma");
    _plegstr = "DEM\000FRF";

    title("\201Taux court r]t[");
    ytics(0.02,0.09,0.01,2);
    _plegctl = {2 6 6.25 4.75};
    xy(seqa(1,1,Nobs),dem[.,2]~frf[.,2]);

  setwind(3);

    title("Taux long R]t[\202\34\56\118\201");
    ytics(0.065,0.09,0.005,0);
    _plegctl = {2 6 3 1};
    xy(seqa(1,1,Nobs),dem[.,3]~frf[.,3]);

    graphprt("-c=1 -cf=sptdem4.eps -w=5");

  endwind;



graphset;
  begwind;
  window2(1,2,0,0.5);

  setwind(1);

    _pdate = ""; _ptitlht = 2.5; _pnum = 0; _paxes = 0;
    title("Comparaison des courbes de taux allemande et francaise");
    draw;

  setwind(2);

    graphset;
    _pdate = ""; _pnum = 2; _pltype = 6|2; _plwidth = 0|5;
    _pnumht = 0.25; _ptitlht = 0.25; _paxht = 0.25;
    let xlab = "1994" "1995" "1996" "1997";
    asclabel(xlab,0);
    xtics(1,Nobs,31*12,12);
    fonts("simplex simgrma");
    _plegstr = "DEM\000FRF";

    title("Spread S]t[");
    ytics(0.00,0.07,0.01,2);
    _plegctl = {2 6 2.25 4.75};
    xy(seqa(1,1,Nobs),dem[.,4]~frf[.,4]);

  setwind(3);

    title("Pente p]t[");
    ytics(-0.02,0.02,0.01,2);
    _plegctl = {2 6 2.5 0.75};
    xy(seqa(1,1,Nobs),dem[.,5]~frf[.,5]);

    graphprt("-c=1 -cf=sptdem5.eps -w=5");

  endwind;


graphset;
    _pdate = ""; _pnum = 2; _pltype = 6|2; _plwidth = 0|5;
    let xlab = "1994" "1995" "1996" "1997";
    asclabel(xlab,0);
    xtics(1,Nobs,31*12,12);
    fonts("simplex simgrma");
    _plegstr = "DEM\000FRF";

    title("Niveau R[[-]]]t[\202\34\2011\202\118\201");
    ytics(0.02,0.08,0.01,2);
    _plegctl = {2 6 6.25 4.75};
    graphprt("-c=1 -cf=sptdem6.eps -w=5");
    xy(seqa(1,1,Nobs),dem[.,6]~frf[.,6]);


