new;
library spt;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates = NS_frf[.,1];
theta = NS_frf[.,2 3 4 5];
theta = theta';

tau = (7|120)/365;

R1 = NS_frf[.,2] + NS_frf[.,3];

R2 = NelsonSiegel_TauxZero(theta,1);
R2 = R2';

F1 = NelsonSiegel_TauxATerme(theta,tau,0);
F1 = F1';

F2 = NelsonSiegel_TauxATerme(theta,tau[2],1);
F2 = F2';

R = R1~R2;
F = F1~F2;

data = dates~R~F;
data = Interpolation_Donnees(calendrier_31jpm(Data,19940101,19961231));
Nobs = rows(data);

dates = data[.,1];
R1 = data[.,2];
R2 = data[.,3];
F1 = data[.,4 5];
F2 = data[.,6];

e1 = (F1 - R1)~(F2 - R2);
e2 = lagn(R1,-7)~lagn(R1,-4*31)~lagn(R2,-4*31);
e2 = e2 - (R1~R1~R2);

e1 = e1 .* ( e2 ./= miss(0,0));

e1 = (e1 .> 0) - (e1 .< 0);
e2 = (e2 .> 0) - (e2 .< 0);

output file = terme10.out reset;

i = 1;
do until i > 3;

  e = packr(miss(e1[.,i].*e2[.,i],0));
  print counts(e,-1|1)/rows(e);
  i = i + 1;
endo;

output off;
