new;
library spt,tsm,optmum,pgraph;
TSMset;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates = NS_frf[.,1];
theta = NS_frf[.,2 3 4 5];
theta = theta';

@------------------->  1  <---------------------@

m = 1/365|1/12|6/12|1;
startDate = 19941010|19940215|19940707|19960101;
endDate = 19960711|19950918|19951220|19960631;
R = zeros(rows(m),1);
x1 = R; x2 = R;
str1 = ""; str2 = "";

i = 1;
do until i > rows(m);

  indx = indexcat(Dates,startDate[i]-1|endDate[i]);
  Nobs = rows(indx);
  indx1 = indx[1];
  startDate[i] = Dates[indx1];
  indx2 = indx[Nobs];
  endDate[i] = Dates[indx2];

  R[i] = NelsonSiegel_TauxZero(theta[.,indx2],m[i]);
  F = miss(zeros(rows(dates),1),0);

  k = 1;
  do until k > Nobs;
    j = indx[k];
    tau = _maturite_entre_2dates(Dates[j],endDate[i]);
    F[j] = NelsonSiegel_TauxATerme(theta[.,j],tau,m[i]);
    k = k + 1;
  endo;

  data_ = dates~F;
  data_ = Interpolation_Donnees(calendrier_31jpm(Data_,19940101,19961231));

  if i == 1;
    data = data_;
  else;
    data = data~data_[.,2];
  endif;

  str1 = str1 $| _date2string(startDate[i]);
  x1[i] = indexcat(data[.,1],startDate[i]);
  str2 = str2 $| _date2string(endDate[i]);
  x2[i] = indexcat(data[.,1],endDate[i]);

  i = i + 1;
endo;

str1 = str1[2:rows(m)+1];
str2 = str2[2:rows(m)+1];

@------------------->  2  <---------------------@

Nobs = rows(data);

F = data[.,2:rows(m)+1];


graphset;
  begwind;
  window2(2,2,0,0.5);

  setwind(1);

    _pdate = ""; _ptitlht = 2.5; _pnum = 0; _paxes = 0;
    title("Evolution des anticipations");
    draw;

  graphset;
    _pdate = ""; _pnum = 2; _pltype = 6|2; _plwidth = 0|5;
    _pnumht = 0.25; _ptitlht = 0.25; _paxht = 0.25;

    let xlab = "1994" "1995" "1996" " ";
    asclabel(xlab,0);
    xtics(1,Nobs,31*12,12);

  i = 1;
  setwind(1+i);

    title("Taux zero un jour");
    _pline = 1~6~0~R[i]~Nobs~R[i]~0~7~0;
    _pmsgstr = str1[i] $+ "\000" $+ str2[i];
    _pmsgctl = (x1[i]-200~F[x1[i],i]-0.01~0.25~0~1~7~0) |
               (x2[i]-170~F[x2[i],i]+0.007~0.25~0~1~7~0) ;
    ytics(0.03,0.08,0.01,0);
    xy(seqa(1,1,Nobs),F[.,i]);

  i = 2;
  setwind(1+i);

    title("Taux zero un mois");
    _pline = 1~6~0~R[i]~Nobs~R[i]~0~7~0;
    _pmsgstr = str1[i] $+ "\000" $+ str2[i];
    _pmsgctl = (x1[i]+10~F[x1[i],i]~0.25~0~1~7~0) |
               (x2[i]+20~F[x2[i],i]+0.001~0.25~0~1~7~0) ;
    ytics(0.05,0.08,0.01,0);
    xy(seqa(1,1,Nobs),F[.,i]);

  i = 3;
  setwind(1+i);

    title("Taux zero six mois");
    _pline = 1~6~0~R[i]~Nobs~R[i]~0~7~0;
    _pmsgstr = str1[i] $+ "\000" $+ str2[i];
    _pmsgctl = (x1[i]-180~F[x1[i],i]-0.006~0.25~0~1~7~0) |
               (x2[i]+20~F[x2[i],i]+0.001~0.25~0~1~7~0) ;
    ytics(0.05,0.08,0.01,0);
    xy(seqa(1,1,Nobs),F[.,i]);

  i = 4;
  setwind(1+i);

    title("Taux zero un an");
    _pline = 1~6~0~R[i]~Nobs~R[i]~0~7~0;
    _pmsgstr = str1[i] $+ "\000" $+ str2[i];
    _pmsgctl = (x1[i]-300~F[x1[i],i]-0.001~0.25~0~1~7~0) |
               (x2[i]-200~F[x2[i],i]-0.001~0.25~0~1~7~0) ;
    ytics(0.038,0.048,0.005,0);
    xy(seqa(1,1,Nobs),F[.,i]);

    graphprt("-c=1 -cf=terme11.eps -w=5");
  endwind;
