new;
library spt,pgraph,tsm;
TSMset;
SPTset;

fichier = spt_data_path $+ "NS_dem"; load NS_dem = ^fichier;
Date_dem = NS_dem[.,1];

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;
Date_frf = NS_frf[.,1];

Date_ = intrsect(Date_dem,Date_frf,1);
Nobs = rows(Date_);

endDate = 19990101|20020101;
m = 1/2|5;
psi = zeros(Nobs,4);

i = 1;
do until i > Nobs;

  pos = indexcat(Date_frf,Date_[i]);
  coefficient_frf = NS_frf[pos,2 3 4 5]';

  pos = indexcat(Date_dem,Date_[i]);
  coefficient_dem = NS_dem[pos,2 3 4 5]';

  j = 1;
  do until j > 2;

    tau = _maturite_entre_2dates(Date_[i],endDate[j]);

    k = 1;
    do until k > 2;

      F_frf = NelsonSiegel_TauxATerme(coefficient_frf,tau,m[k]);
      F_dem = NelsonSiegel_TauxATerme(coefficient_dem,tau,m[k]);

      psi[i,2*(j-1)+k] = F_frf - F_dem;
      
      k = k + 1;
    endo;

    j = j + 1;
  endo;

  i = i + 1;
endo;

data = Interpolation_donnees(calendrier_31jpm(Date_~psi,19940101,19961231));
psi = 100*data[.,2 3 4 5];
Nobs = rows(data);

graphset;
  begwind;
  window2(2,2,0,0.5);

  setwind(1);

    _pdate = ""; _ptitlht = 2.5; _pnum = 0; _paxes = 0;
    fonts("simplex simgrma");
    title("Evolution de la credibilite");
    draw;

    graphset;
    _pdate = ""; _pnum = 2; _pltype = 6|4; _plwidth = 0|0;
    _pnumht = 0.25; _ptitlht = 0.25; _paxht = 0.25;
    fonts("simplex simgrma");

  setwind(2);

    title("t+\202t\201 = 01/01/1999\Lm = 1/2");
    let xlab = "1994" "1995" "1996" "1997";
    asclabel(xlab,0);
    ylabel("en %");
   _pline = 1~4~0~0~Nobs~0~0~7~0;
    xtics(1,Nobs,31*12,12); 
    ytics(-0.5,1.5,0.5,5); 

    xy(seqa(1,1,Nobs),psi[.,1]);
  
  setwind(3);

    title("t+\202t\201 = 01/01/1999\Lm = 5");
    ytics(-0.5,1.5,0.5,5); 
    xy(seqa(1,1,Nobs),psi[.,2]);

  setwind(4);

    title("t+\202t\201 = 01/01/2002\Lm = 1/2");    
    ytics(-0.8,0.8,0.4,4);
    xy(seqa(1,1,Nobs),psi[.,3]);

  setwind(5);

    title("t+\202t\201 = 01/01/2002\Lm = 5");    
    ytics(-0.8,0.8,0.4,4); 
    xy(seqa(1,1,Nobs),psi[.,4]);

    graphprt("-c=1 -cf=change10.eps"); 
  endwind;
