new;
library spt,pgraph,tsm;
TSMset;
SPTset;

fichier = spt_data_path $+ "change"; change = loadd(fichier);

change = Interpolation_donnees(calendrier_31jpm(change,19940101,19961231));
change = ln(change[.,2]/100);

S2 = change;

delta = {};
m = 31*(1|6|12);

i = 1;
do until i > rows(m);
  S1 = shiftr(change',m[i],miss(0,0))';
  delta = delta ~ ( (S2-S1)/(m[i]/365) );
  i = i + 1;
endo;

Nobs = rows(delta);

graphset;
  begwind;
  window2(1,2,0,0.5);

  setwind(1);

    _pdate = ""; _ptitlht = 2.5; _pnum = 0; _paxes = 0;
    title("Evolution des taux de depreciation");
    draw;

    graphset;
    _pdate = ""; _pnum = 2; _pltype = 6|4; _plwidth = 0|0;
    _pnumht = 0.25; _ptitlht = 0.25; _paxht = 0.25;
    fonts("simplex simgrma");

  setwind(2);

    let xlab = "1994" "1995" "1996" "1997";
    asclabel(xlab,0);
    xtics(1,Nobs,31*12,12);
    ytics(-0.4,0.4,0.1,10);
    _plegctl = {2 7 2 1};
    _plegstr = "\202d\34\201t,1/12\202\118\201";
    xy(seqa(1,1,Nobs),delta[.,1]);

  setwind(3);

    ytics(-0.1,0.1,0.05,5);
    _plegstr = "\202d\34\201t,1/2\202\118\000"\
               "\202d\34\201t,1\202\118\201";
    xy(seqa(1,1,Nobs),delta[.,2 3]);

    graphprt("-c=1 -cf=change2.eps");

  endwind;
