new;
library spt,pgraph,tsm;
TSMset;
SPTset;

fichier = spt_data_path $+ "change"; change = loadd(fichier);

change = Interpolation_donnees(calendrier_31jpm(change,19940101,19961231));
change = ln(change[.,2]/100);

S2 = change;

delta = {};
m = 31;

i = 1;
do until i > rows(m);
  S1 = shiftr(change',m[i],miss(0,0))';
  delta = delta ~ ( (S2-S1)/(m[i]/365) );
  i = i + 1;
endo;

Nobs = rows(delta);

y =  packr(delta);
N = 1024;
y = y[1:N];
{H,G,Htilde,Gtilde} = Daubechies(8);

/* Analyse par paquets d'ondelettes */
pkt = wpkt(y,H,G,6);

/* Analyse par ondelettes */
w = wt(y,H,G,0);

/* Scalogramme */
output file = change3.out reset;
E = scalogram(w);
output off;

/* Decomposition en sous-bandes */
w56 = extract(w,5|6);
y56 = iwt(w56,Htilde,Gtilde,0);
data = miss(zeros(Nobs,1),0);
data[34:1024+33,.] = y56;


graphset;
  begwind;
  window2(1,2,0,0.5);

  setwind(1);
    fonts("simplex simgrma");
    _pdate = ""; _ptitlht = 2.5; _pnum = 0; _paxes = 0;
    title("Analyse statistique de \202d\34\201t,1/12\202\118\201");
    draw;

  setwind(2);

    graphset;
    _wgrid = 1; _wcolor = 0;
    call wpkPlot(pkt,1);
    _pnum = 2; _pdate = ""; _ptitlht = 0.27; _paxht = 0.27; _pnumht = 0.27;
    title("Analyse par paquets d'ondelettes");
    xtics(0,N/2-1,128,0);
    ylabel("niveau de resolution");
    draw;

  setwind(3);

    graphset;
    _pdate = ""; _pnum = 2; _ptitlht = 0.27; _pnumht = 0.27; _paxht = 0.27;
    let xlab = "1994" "1995" "1996" "1997";
    title("Decomposition en sous-bandes");
    asclabel(xlab,0);
    xtics(1,Nobs,31*12,12);
    ytics(-0.2,0.2,0.1,10);
    _plegstr = "b]5+6[";
    _plegctl = {2 8 2 1};
    xy(seqa(1,1,Nobs),data);

    graphprt("-c=1 -cf=change3.eps");

  endwind;

