new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates_ = NS_frf[.,1];
coefficients = NS_frf[.,2 3 4 5];

R0 = coefficients[.,1] + coefficients[.,2];
Rinf = coefficients[.,1];
tau = 1/12|2/12|3/12|6/12|9/12|1|2|3|4|5|6|7|8|9|10|15|20|25|30;

TauxZero = NelsonSiegel_TauxZero(coefficients',tau)';
TauxZero = R0~TauxZero~Rinf;

var = "0"|"1/12"|"2/12"|"3/12"|"1/2"|"9/12"|"1"|
      "2"|"3"|"4"|"5"|"6"|"7"|"8"|"9"|"10"|"15"|"20"|"25"|"30"|"infini";

__output = 0;

{va,ve,scores} = acp(var,TauxZero,1,5);
saturation = vread(_acp,"TAB_sat");

c1 = saturation[.,1];
c2 = saturation[.,2];
t = seqa(0,2*pi/100,101);

Nvar = rows(var);

graphset;   
  _pnum = 2; _pdate = ""; _pcross = 1;
  fonts("simplex simgrma");
  title("\201cercle des correlations");
    _pmsgstr = "0\0001/12\0002/12\0003/12\0006/12\0009/12\0001"\
             "\0002\0003\0004\0005\0006\0007"\
             "\0008\0009\000 \000 \000 \000 \000 \000\202\56\201";
  _pmsgctl = 0.00+c1~c2~ones(Nvar,5).*(0.17~0~1~7~0.1); 
  _psym = c1~c2~ones(Nvar,5).*(8~3~2~1~1); 
  xtics(0.75,1,0.05,0);
  ytics(-0.7,0.3,0.2,0);
  xlabel("1[er] axe factoriel        ");
  ylabel("2[eme] axe factoriel       ");
  graphprt("-c=1 -cf=acp1.eps");
  xy(cos(t),sin(t)); 
