new;
library spt,pgraph,tsm,optmum;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates_ = NS_frf[.,1];

coefficients = NS_frf[.,2 3 4 5];
R0 = coefficients[.,1] + coefficients[.,2];
Rinf = coefficients[.,1];
tau = 1/12|2/12|3/12|6/12|9/12|1|2|3|4|5|6|7|8|9|10|15|20|25|30;

TauxZero = NelsonSiegel_TauxZero(coefficients',tau)';
TauxZero = R0~TauxZero~Rinf;

var = "0"|"1/12"|"2/12"|"3/12"|"1/2"|"9/12"|"1"|
      "2"|"3"|"4"|"5"|"6"|"7"|"8"|"9"|"10"|"15"|"20"|"25"|"30"|"infini";

__output = 0;

{va,ve,scores} = acp(var,TauxZero,1,5);
{S,P,N} = NelsonSiegel_SPN(NS_frf,1/100,1);

data = S~P;
data1 = selif(data, scores[.,2] .< 0);
data2 = selif(data, scores[.,2] .>= 0);
data3 = selif(data, scores[.,2] .< -1);
data4 = selif(data, scores[.,2] .>= 1);

x1 = {};
d1 = {};

i = 1;
_Kernel[1 2] = 0|0.05;
{xi,di,F,retcode} = Kernel(data1[.,i]);
x1 = x1~xi;
d1 = d1~di;
{xi,di,F,retcode} = Kernel(data2[.,i]);
x1 = x1~xi;
d1 = d1~di;
{xi,di,F,retcode} = Kernel(data3[.,i]);
x1 = x1~xi;
d1 = d1~di;
{xi,di,F,retcode} = Kernel(data4[.,i]);
x1 = x1~xi;
d1 = d1~di;

x2 = {};
d2 = {};

i = 2;
_Kernel[1 2] = -0.03|0.03;
{xi,di,F,retcode} = Kernel(data1[.,i]);
x2 = x2~xi;
d2 = d2~di;
{xi,di,F,retcode} = Kernel(data2[.,i]);
x2 = x2~xi;
d2 = d2~di;
{xi,di,F,retcode} = Kernel(data3[.,i]);
x2 = x2~xi;
d2 = d2~di;
{xi,di,F,retcode} = Kernel(data4[.,i]);
x2 = x2~xi;
d2 = d2~di;

graphset;
  begwind;
  window(2,2,0);
  
  _pnum = 2; _paxht = 0.25; _pnumht = 0.20; _ptitlht = 0.25;
  ytics(0,100,25,0);  
  fonts("simplex simgrma complex");
  _pline = 1~4~0~0~0~100~0~7~1;

  setwind(1);
    
    _plegstr = "\203J\201]2[\202\34\203R\201[-]\202\118 \201\60 0"\
               "\000\203J\201]2[\202\34\203R\201[-]\202\118 \202\62 \2010";    
    _plegctl = {2 9 7 3.5};
    title("Fonction de densite du spread");
    xy(x1[.,1 2],d1[.,1 2]);

  nextwind;

    _plegctl = {2 9 -2 3.5};
    title("Fonction de densite de la pente");
    xy(x2[.,1 2],d2[.,1 2]);

  nextwind;

    _plegstr = "\203J\201]2[\202\34\203R\201[-]\202\118 \201\60 -1"\
               "\000\203J\201]2[\202\34\203R\201[-]\202\118 \202\62 \2011";
    _plegctl = {2 9 7 3.5};
    title("Fonction de densite du spread");
    xy(x1[.,3 4],d1[.,3 4]);

  nextwind;

    _plegctl = {2 9 -2 3.5};
    title("Fonction de densite de la pente");
    xy(x2[.,3 4],d2[.,3 4]);

  graphprt("-c=1 -cf=acp8.eps");
  endwind;