new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates_ = NS_frf[.,1];

coefficients = NS_frf[.,2 3 4 5];
R0 = coefficients[.,1] + coefficients[.,2];
Rinf = coefficients[.,1];
tau = 1/12|2/12|3/12|6/12|9/12|1|2|3|4|5|6|7|8|9|10|15|20|25|30;

TauxZero = NelsonSiegel_TauxZero(coefficients',tau)';
TauxZero = R0~TauxZero~Rinf;

var = "0"|"1/12"|"2/12"|"3/12"|"1/2"|"9/12"|"1"|
      "2"|"3"|"4"|"5"|"6"|"7"|"8"|"9"|"10"|"15"|"20"|"25"|"30"|"infini";

__output = 0;

{va,ve,scores} = acp(var,TauxZero,1,5);
qlt_obs = vread(_acp,"QLT_obs");
indx = rev(sortind(qlt_obs[.,3]));

ind = indx[1:3];

tau = seqa(1/12,1/12,12*16);
theta = coefficients[ind,.];

TauxZero = NelsonSiegel_TauxZero(theta',tau);

graphset;
  title("Courbe des taux pour les dates"\
        "\Lles mieux representees par le troisieme facteur");
  _pnum = 2; _pdate = ""; _pltype = 6|1|4;
  _plegstr = "10/06/1994\00005/09/1995\00009/11/1995";
  _plegctl = {2 6 5 1.5};
  fonts("simplex simgrma");
  xlabel("\202t\201");
  ytics(0.05,0.08,0.01,10);
  graphprt("-c=1 -cf=acp9.eps");
  xy(tau,TauxZero);