new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;
fichier = spt_data_path $+ "NS_dem"; load NS_dem = ^fichier;

Dates1 = NS_frf[.,1];
Dates2 = NS_dem[.,1];
Dates = intrsect(Dates1,Dates2,1);
Nobs = rows(Dates);

data1 = zeros(Nobs,5);
data2 = zeros(Nobs,5);

i = 1;
do until i > Nobs;
  indx = indexcat(Dates1,Dates[i]);
  data1[i,.] = NS_frf[indx,.];
  indx = indexcat(Dates2,Dates[i]);
  data2[i,.] = NS_dem[indx,.];
  i = i + 1;
endo;

tau = 3|10;

TauxZero = {};
coefficients = data1[.,2 3 4 5];
R0 = coefficients[.,1] + coefficients[.,2];
Rinf = coefficients[.,1];
Rtau = NelsonSiegel_TauxZero(coefficients',tau)';
TauxZero = TauxZero~R0~Rtau;
coefficients = data2[.,2 3 4 5];
R0 = coefficients[.,1] + coefficients[.,2];
Rinf = coefficients[.,1];
Rtau = NelsonSiegel_TauxZero(coefficients',tau)';
TauxZero = TauxZero~R0~Rtau;

var = "FRF R(0)"|"FRF R(3)"|"FRF R(10)"|"DEM R(0)"|"DEM R(3)"|"DEM R(10)";

__output = 1;

output file = mltltrl1.out reset;

{va,ve,scores} = acp(var,TauxZero,1,4);

print "                  ---------------------------------";
print "Vecteurs propres";
print ve;

output off;

saturation = vread(_acp,"TAB_sat");

c1 = saturation[.,1];
c2 = saturation[.,2];
t = seqa(0,2*pi/100,101);

Nvar = rows(var);

graphset;   
  _pnum = 2; _pdate = ""; _pcross = 1;
  fonts("simplex simgrma");
  title("\201cercle des correlations");
  _pmsgstr = "FRF R(0)\000FRF R(3)\000FRF R(10)\000"\
             "DEM R(0)\000DEM R(3)\000DEM R(10)";
  _pmsgctl = -0.07+c1~c2~ones(Nvar,5).*(0.17~0~1~7~0.1); 
  _psym = c1~c2~ones(Nvar,5).*(9~3~2~1~1); 
  xtics(0.6,1,0.1,0);
  ytics(-0.8,0.6,0.2,0); 
  xlabel("1[er] axe factoriel        ");
  ylabel("2[eme] axe factoriel       ");
  graphprt("-c=1 -cf=mltltrl1.eps");
  xy(cos(t),sin(t)); 

qlt_obs = vread(_acp,"QLT_obs");
data = Dates~scores[.,3]~qlt_obs[.,3];
data = Interpolation_Donnees(calendrier_31jpm(Data,19940101,19961231));
Nobs = rows(data);

graphset;
  _pdate = ""; _pnum = 2;
  let xlab = "1994" "1995" "1996" "1997";
  asclabel(xlab,0);
  xtics(1,Nobs,31*12,12);
  ytics(-2,2,1,10);
  _pline = 1~4~0~0~Nobs~0~0~7~1;
   title("3[eme] axe factoriel\Lscore des observations");  
  graphprt("-c=1 -cf=mltltrl2.eps");
  xy(seqa(1,1,Nobs),data[.,2]);

  let xlab = "1995" "1996" "1997" "";
  asclabel(xlab,0);
  ytics(0,100,10,10);
  title("3[eme] axe factoriel\Lqualite de representation des observations");
  graphprt("-c=1 -cf=mltltrl3.eps");
  bar(seqa(1,1,Nobs),data[.,3]);
