new;
library spt,pgraph,tsm,optmum;
TSMset;
SPTset;

cls;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;
fichier = spt_data_path $+ "NS_dem"; load NS_dem = ^fichier;

Dates1 = NS_frf[.,1];
Dates2 = NS_dem[.,1];
Dates = intrsect(Dates1,Dates2,1);
Nobs = rows(Dates);

data1 = zeros(Nobs,5);
data2 = zeros(Nobs,5);

i = 1;
do until i > Nobs;
  indx = indexcat(Dates1,Dates[i]);
  data1[i,.] = NS_frf[indx,.];
  indx = indexcat(Dates2,Dates[i]);
  data2[i,.] = NS_dem[indx,.];
  i = i + 1;
endo;

tau = 1|5;

coefficients = data1[.,2 3 4 5];
R0 = coefficients[.,1] + coefficients[.,2];
Rinf = coefficients[.,1];
Rtau = NelsonSiegel_TauxZero(coefficients',tau)';

TauxZero_frf = Rtau;

coefficients = data2[.,2 3 4 5];
R0 = coefficients[.,1] + coefficients[.,2];
Rinf = coefficients[.,1];
Rtau = NelsonSiegel_TauxZero(coefficients',tau)';

TauxZero_dem = Rtau;


y = TauxZero_frf~TauxZero_dem;
y = y - lag1(y);
K = cols(y);

output file = mltltrl4.out reset;

{CR,p} = criteria(y,1,5);

{theta,stderr,Mcov,Logl} = varx_LS(y,0,1);

tstudent = theta./stderr;
signif = abs(tstudent) .> 1.96;
BB = reshape(theta,rows(theta)/K,K)';
signif = reshape(signif,rows(theta)/K,K)';
format 8,3;
print BB;
print signif;
print _varx_SIGMA;

output off;


/*
**  A procedure to select the order of a VARX model
*/

proc (2) = criteria(Y,X,p_max);
  local old,K,T,m,CR,L,D,SIGMA;
  local omat,fmt,mask,p;

  old = _print;
  K = cols(Y);
  CR = zeros(p_max+1,7);

  m = 0;
  do until m>p_max;

    _print = 0;
    call varx_ML(Y,X,m);
    T = rows(packr(Y))-m;

    SIGMA = _varx_SIGMA;
    D = det(SIGMA);
    L = ln(D);

    CR[1+m,1] = L+(K^2)*m*ln(T)/T;                  /* BIC */
    CR[1+m,2] = L+3*m*(K^2)/T;                      /* AIC alpha = 3 */
    CR[1+m,3] = L+(1+m*(K^2)/T)/(1-(m*(K^2)-2)/T);  /* AICc */
    CR[1+m,4] = D*(1+2*(m*(K^2)+1)/T)^K;            /* SIC  */
    CR[1+m,5] = D*(((T+K*m+1)/(T-K*m-1))^K);        /* MFPE */
    CR[1+m,6] = L+2*(K^2)*m/T;                      /* AIC  */
    CR[1+m,7] = L+2*(K^2)*m*ln(ln(T))/T;            /* HQ   */

    m = m+1;
  endo;

  P = minindc(CR)-1;
  _print = old;

  if _print == 1;

    m = seqa(0,1,p_max+1);

    print chrs(45*ones(79,1));
    print "Lags      BIC       AICa      AICc        SIC         FPE       AIC"
           "       HQ";
    print chrs(45*ones(79,1));

    omat = "Opt."~p';
    mask = 0~1~1~1~1~1~1~1;
    let fmt[8,3] =
       "-*.*s"  4 4
       "*.*lf" 8  0
       "*.*lf" 10 0
       "*.*lf" 10 0
       "*.*lf" 12 0
       "*.*lf" 12 0
       "*.*lf" 10 0
       "*.*lf" 10 0;
    call printfm(omat,mask,fmt); print; print chrs(45*ones(79,1));

    omat = m~CR;
    mask = 1;
    let fmt[8,3] =
       "*.*lf"  4 0
       "*.*lf" 10 3
       "*.*lf" 10 3
       "*.*lf" 10 3
       "*.*lf" 12 3
       "*.*lf" 12 3
       "*.*lf" 10 3
       "*.*lf" 10 3;
    call printfm(omat,mask,fmt);
  endif;
  retp(CR,p);
endp;


