new;
library spt;
SPTset;

cls;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;
fichier = spt_data_path $+ "NS_dem"; load NS_dem = ^fichier;

Dates1 = NS_frf[.,1];
Dates2 = NS_dem[.,1];
Dates = intrsect(Dates1,Dates2,1);
Nobs = rows(Dates);

data1 = zeros(Nobs,5);
data2 = zeros(Nobs,5);

i = 1;
do until i > Nobs;
  indx = indexcat(Dates1,Dates[i]);
  data1[i,.] = NS_frf[indx,.];
  indx = indexcat(Dates2,Dates[i]);
  data2[i,.] = NS_dem[indx,.];
  i = i + 1;
endo;

NS_frf = data1[.,1 2 3 4 5];
NS_dem = data2[.,1 2 3 4 5];

{S_frf,P,N} = NelsonSiegel_SPN(NS_frf,0,1);
{S_dem,P,N} = NelsonSiegel_SPN(NS_dem,0,1);

tau = 1|5|10;

coefficients = data1[.,2 3 4 5];
R0 = coefficients[.,1] + coefficients[.,2];
Rtau = NelsonSiegel_TauxZero(coefficients',tau)';

S_frf = (Rtau-R0)~S_frf;

coefficients = data2[.,2 3 4 5];
R0 = coefficients[.,1] + coefficients[.,2];
Rtau = NelsonSiegel_TauxZero(coefficients',tau)';

S_dem = (Rtau-R0)~S_dem;


output file = mltltrl6.out reset;

i = 1;
do until i > 4;

  call reg_fm(S_frf[.,i],ones(Nobs,1),S_dem[.,i]);

  i = i + 1;
endo;


output off;