new;
library spt,pgraph;
SPTset;

declare external NB = 100;

sigmaJ = 0.2;
rJ = 0.1;
muJ = 0.9;
lambdaJ = 0.05;

h = 0.1;
k = seqa(1/100,1/100,101);
theta = seqa(0,1/25,25)';

F1 = zeros(25,101);

i = 1;
do until i > 101;
  F1[.,i] = digamma_star(k[i],h,theta,muJ,sigmaJ,lambdaJ,rJ);
  i = i + 1;
endo;


sigmaJ = 0.8;
rJ = -0.10;
muJ = 0.1;
lambdaJ = 0.05;

h = 0.1;
k = seqa(1/100,1/100,101);
theta = seqa(0,1/25,25)';

F2 = zeros(25,101);

i = 1;
do until i > 101;
  F2[.,i] = digamma_star(k[i],h,theta,muJ,sigmaJ,lambdaJ,rJ);
  i = i + 1;
endo;


graphset;

  begwind;
  window(2,2,0);

  setwind(1);

    _pdate=""; _pframe = 0; _pnum = 2; 
    _paxht = 0.20; _pnumht = 0.20; _ptitlht = 0.25;
    fonts("simplex simgrma");
    title("\202m\201]j[ = 0.9 \202s\201]j[ = 0.2 \202l\201 = 0.05 "\
          "\201r\201]j[ = 0.1\Lh = 0.1");
    fonts("simplex simgrma complex");
    ytics(0,1,0.2,0);
    xtics(0,1,0.2,0);
    ztics(0,1,1,1);
    xlabel("k");
    ylabel("\202Q\201");
    volume(2,2,.2);
    view(-3,-3,16);
    _pzclr  = { 0, 10 };
    surface(k',theta',F1);

  setwind(2);

    _paxht = 0.25; _pnumht = 0.25; 
    title("");
    _pzclr  = { 7, 10 };
    _pmsgctl = { 0.2 0.7 0.30 0 1 7 0};
    _pmsgstr = "\203zone de stabilite\201";
    contour(k',theta',F1);

  setwind(3);

    _paxht = 0.20; _pnumht = 0.20;    
    title("\202m\201]j[ = 0.1 \202s\201]j[ = 0.8 \202l\201 = 0.05 "\
          "\201r\201]j[ = -0.1\Lh = 0.1");
    volume(2,2,.2);
    view(-3,-3,16);
    _pzclr  = { 0, 10 };
    _pmsgctl = 0;
    surface(k',theta',F2);

  setwind(4);

    _paxht = 0.25; _pnumht = 0.25; 
    title("");
    _pzclr  = { 7, 10 };
    _pmsgctl = { 0.2 0.7 0.30 0 1 7 0};
    contour(k',theta',F2);

    graphprt("-c=1 -cf=stable2.eps");
  endwind;






proc digamma(z,k,h,theta,muJ,sigmaJ,lambdaJ,rJ);
  local alpha,beta;
  alpha = (sigmaJ^2).*(k./(h^2)).*(cos(z.*h)-1)-rJ.*k;
  beta = (muJ-lambdaJ.*sigmaJ).*sin(z.*h).*(k./h);
  retp( (1-2*theta).*(alpha^2 + beta^2) + 2*alpha );
endp;

proc digamma_star(k,h,theta,muJ,sigmaJ,lambdaJ,rJ);
  local z;
  z = seqa(0,2*pi/h/NB,NB);
  retp( maxc(digamma(z,k,h,theta,muJ,sigmaJ,lambdaJ,rJ)) .< 0);
endp;

