new;
library tsm,optmum,spt,pgraph;
TSMset;

rndseed 456;

/* Parametres du mouvement brownien geometrique */
x0 = 10; mu = 0.5; sigma = 1;

t0 = 0; T = 1;
N = 10001;
k = (T-t0)/(N-1);

dW = rndn(N-1,1)*sqrt(k);

Nstar = N|6|11|51|101|251;
S = miss(zeros(N,6),0); tt = S;

i = 1;
do until i > 6;

  Ni = Nstar[i];
  M = (N-1)/(Ni-1);

  kstar = (T-t0)/(Ni-1);
  dti = seqa(0,kstar,Ni);

  dWi = 0|sumc(reshape(dW,Ni-1,M)');

  Si = x0*exp( (mu-0.5*sigma^2)*dti + sigma*cumsumc(dWi) );

  S[1:Ni,i] = Si;
  tt[1:Ni,i] = t0 + dti;

  i = i + 1;

endo;

graphset;
  _pdate = ""; _pnum = 2;
  title("Passage du temps continu au temps discret");
  _plegstr = "trajectoire continue (N = 10001)\000trajectoire discrete N[*] = 6";
  _plegctl = {2 5 2.2 1.1};
  _pltype = 6|1;
  xlabel("t"); ylabel("x(t)");
  xtics(0,1,0.1,0);
  ytics(4,24,4,4);
  graphprt("-c=1 -cf=con2dis1.eps");
  xy(tt[.,1:2],S[.,1:2]);


graphset;
  begwind;
  window2(2,2,0,0.5);

  setwind(1);

    _pdate = ""; _ptitlht = 2.0; _pnum = 0; _paxes = 0;
    title("Convergence des trajectoires discretes vers la trajectoire continue");
    draw;

  graphset;
    _pdate = ""; _pnum = 2; _pltype = 6|1; _plwidth = 0|0;
    _pnumht = 0.25; _ptitlht = 0.25; _paxht = 0.30;
    xlabel("t"); ylabel("x(t)");
    xtics(0,1,0.1,0);
    ytics(4,24,4,4);

  setwind(2);

    title("N[*] = 11");
    xy(tt[.,3],S[.,3]);

  setwind(3);

    title("N[*] = 51");
    xy(tt[.,4],S[.,4]);

  setwind(4);

    title("N[*] = 101");
    xy(tt[.,5],S[.,5]);

  setwind(5);

    title("N[*] = 251");
    xy(tt[.,6],S[.,6]);

    graphprt("-c=1 -cf=con2dis2.eps");
endwind;