new;
library spt,tsm,optmum,pgraph;

cls;

declare external S; 
declare external k; 
declare external Nobs;


proc pMu(t,x,theta);
  retp(theta[1]*(theta[2]-x));
endp;


proc PSigma(t,x,theta);
  retp(theta[3]);
endp;


proc (1) = SimulationModele(theta);
  local a,b,sigma,t,x;

  a = theta[1];
  b = theta[2];
  sigma = theta[3];

  {t,x} = simulation_OU(b,a,b,sigma,0,k*Nobs,Nobs,S);

  retp(x);
endp;



theta = 0.8|0.1|0.06;
k_ = 1|0.5|0.1|0.05;

Nobs = 250;
seed = 456;

est1 = zeros(11,4);
est2 = zeros(11,4);
est3 = zeros(11,4);

est1[1,.] = theta[1].*ones(1,4);
est2[1,.] = theta[2].*ones(1,4);
est3[1,.] = theta[3].*ones(1,4);


__output = 0;
_opgtol = 0.0001;

/*

S = 1;
do until S > 10;
  j = 1;
  do until j > 4;

    sv = a|b|sigma;

    k = k_[j];
    theta_ei = 
             ei2_eds(theta,&pMu,&pSigma,0,k,sv,0,0,&simulationModele,seed,eye(3));

    est1[1+S,j] = theta[1];
    est2[1+S,j] = theta[2];
    est3[1+S,j] = theta[3];

    str = ftos(S,"S = %lf",2,0) $+ ftos(k," --- k = %lf",3,2);
    locate 5,5; print /flush str;
   
    j = j + 1;
  endo;

  S = S + 1;
endo;


save simul23 = est1;
save simul24 = est2;
save simul25 = est3;

*/

load est1 = simul23;
load est2 = simul24;
load est3 = simul25;


S = seqa(0,1,11);

graphset;
  begwind;
  window(2,2,0);

  setwind(1);

    _pdate = ""; _pnum = 0; _paxes = 0; _ptitlht = 0.30;
    fonts("simplex simgrma complex microb");
    _pmsgstr = "\203Methode de l'inference indirecte\000"\
                   "Recherche du vecteur \202Q\201]0[\000"\
                   "pour le processus d'Ornstein-Uhlenbeck\000"\
                   "250 observations";
           
    _pmsgctl = 
               0.05~0.75~0.23~0~1~7~0 |
               0.05~0.6~0.23~0~1~7~0 |
               0.05~0.45~0.23~0~1~7~0 |
               0.05~0.2~0.23~0~1~7~0 ;            
    draw;

  graphset;
    _pnum = 2; _pdate = ""; _pnumht = 0.25; _ptitlht = 0.25; _paxht = 0.25;
    _pltype = 3;
    fonts("simplex simgrma");
    _pstype = 9|10|11|12;
    _plctrl = 1;
    _psymsiz = 5;
    xlabel("S");

    xtics(0,10,1,0);
  
  setwind(2);

    title("\201parametre a");
    ytics(0.5,2,0.5,0);
    xy(S,est1);

  setwind(3);

    title("\201parametre b");
    ytics(0.08,0.11,0.01,0);
    _plegstr = "k = 1\000k = 0.5\000k = 0.1\000k = 0.05";
    _plegctl = {2 6 4.25 1.25};
    xy(S,est2);

  setwind(4);


    title("\201parametre \202s\201");
    ytics(0.05,0.13,0.02,0);
    _plegctl = 0;
    xy(S,est3);
   
    graphprt("-c=1 -cf=ei1.eps");

endwind;
