new;
library spt,pgraph,tsm,optmum;
TSMset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates_ = NS_frf[.,1];
mu1 = NS_frf[.,2]; mu2 = NS_frf[.,3]; mu3 = NS_frf[.,4]; tau1 = NS_frf[.,5];
R0 = mu1 + mu2;

data = Interpolation_Donnees( calendrier_31jpm(Dates_~R0,19940101,19961231) );
Nobs = rows(data);
Dates_ = data[.,1]; R0 = data[.,2];


proc Mu(t,x,theta);
  retp( theta[1] + theta[2]*(x^theta[3]) );
endp;

proc Sigma(t,x,theta);
  retp( theta[4]*(x^theta[5]) );
endp;


proc gradMu(t,x,theta);
  local Nobs;
  Nobs = rows(x);
  retp( ones(Nobs,1)~(x^theta[3])~(theta[2]*ln(x).*(x^theta[3]))~zeros(Nobs,2) );
endp;

proc gradSigma(t,x,theta);
  local Nobs;
  Nobs = rows(x);
  retp( zeros(Nobs,3)~(x^theta[5])~(theta[4]*ln(x).*(x^theta[5])) );
endp;

_eds_gradp = &gradMu|&gradSigma; 
_tsm_parnm = "alpha"|"beta"|"eta"|"sigma"|"gamma";

k = 1/365;

rndseed 123;
sv = rndu(4,1);
estim = miss(zeros(5,12),0);

output file = etude1.out reset;


/* Modele P10 */

CC = 0~0~1~0~0;
c = 1;
{RR,r} = Explicit_to_Implicit(CC,c);
_print = 0; 
tsm_Mcov = 0;
{theta,stderr,Mcov,Logl} = ml_eds(R0,&Mu,&Sigma,0,k,sv,RR,r);
SV10 = theta;
_print = 1;
_tsm_Mcov = 3;
{theta10,stderr10,Mcov10,Logl10} = ml_eds(R0,&Mu,&Sigma,0,k,theta,0,0);
estim[.,10] = theta10;

_tsm_Mcov = 1;


/* Modele P1 */

CC = 0~1~0~0~0 |
     0~0~1~0~0 |
     0~0~0~0~1 ;
c = 0|1|0;
{RR,r} = Explicit_to_Implicit(CC,c);
sv = invpd(RR'RR)*RR'(SV10-r);
{theta,stderr,Mcov,Logl} = ml_eds(R0,&Mu,&Sigma,0,k,sv,RR,r);
estim[.,1] = theta;
g = 2;
call test_LR(Logl10,Logl,g);
call test_LM(_ml_derivatives,g,1);
call test_Wald(CC,c,theta10,Mcov10,g);


/* Modele P2 */

CC = 0~0~1~0~0 |
     0~0~0~0~1 ;
c = 1|0;
{RR,r} = Explicit_to_Implicit(CC,c);
sv = invpd(RR'RR)*RR'(SV10-r);
{theta,stderr,Mcov,Logl} = ml_eds(R0,&Mu,&Sigma,0,k,sv,RR,r);
estim[.,2] = theta;
g = 2;
call test_LR(Logl10,Logl,g);
call test_LM(_ml_derivatives,g,0);
call test_Wald(CC,c,theta10,Mcov10,g);


/* Modele P3 */

CC = 1~0~0~0~0 |
     0~1~0~0~0 |
     0~0~1~0~0 |
     0~0~0~0~1 ;
c = 0|0|1|1;
{RR,r} = Explicit_to_Implicit(CC,c);
sv = invpd(RR'RR)*RR'(SV10-r);
{theta,stderr,Mcov,Logl} = ml_eds(R0,&Mu,&Sigma,0,k,sv,RR,r);
estim[.,3] = theta;
g = 3;
call test_LR(Logl10,Logl,g);
call test_LM(_ml_derivatives,g,1);
call test_Wald(CC,c,theta10,Mcov10,g);


/* Modele P4 */

CC = 0~0~1~0~0 |
     0~0~0~0~1 ;
c = 1|1;
{RR,r} = Explicit_to_Implicit(CC,c);
sv = invpd(RR'RR)*RR'(SV10-r);
{theta,stderr,Mcov,Logl} = ml_eds(R0,&Mu,&Sigma,0,k,sv,RR,r);
estim[.,4] = theta;
g = 2;
call test_LR(Logl10,Logl,g);
call test_LM(_ml_derivatives,g,0);
call test_Wald(CC,c,theta10,Mcov10,g);


/* Modele P5 */

CC = 1~0~0~0~0 |
     0~1~0~0~0 |
     0~0~1~0~0 |
     0~0~0~0~1 ;
c = 0|0|1|1.5;
{RR,r} = Explicit_to_Implicit(CC,c);
sv = invpd(RR'RR)*RR'(SV10-r);
{theta,stderr,Mcov,Logl} = ml_eds(R0,&Mu,&Sigma,0,k,sv,RR,r);
estim[.,5] = theta;
g = 3;
call test_LR(Logl10,Logl,g);
call test_LM(_ml_derivatives,g,1);
call test_Wald(CC,c,theta10,Mcov10,g);


/* Modele P6 */

CC = 0~0~1~0~0 |
     0~0~0~0~1 ;
c = 1|0.5;
{RR,r} = Explicit_to_Implicit(CC,c);
sv = invpd(RR'RR)*RR'(SV10-r);
{theta,stderr,Mcov,Logl} = ml_eds(R0,&Mu,&Sigma,0,k,sv,RR,r);
estim[.,6] = theta;
g = 2;
call test_LR(Logl10,Logl,g);
call test_LM(_ml_derivatives,g,0);
call test_Wald(CC,c,theta10,Mcov10,g);


/* Modele P7 */

CC = 0~0~1~0~0 |
     0~0~0~0~1 ;
c = 0.5|0.5;
{RR,r} = Explicit_to_Implicit(CC,c);
sv = invpd(RR'RR)*RR'(SV10-r);
{theta,stderr,Mcov,Logl} = ml_eds(R0,&Mu,&Sigma,0,k,sv,RR,r);
estim[.,7] = theta;
g = 2;
call test_LR(Logl10,Logl,g);
call test_LM(_ml_derivatives,g,0);
call test_Wald(CC,c,theta10,Mcov10,g);


/* Modele P8 */

CC = 0~0~1~0~0 ;
c = 1;
{RR,r} = Explicit_to_Implicit(CC,c);
sv = invpd(RR'RR)*RR'(SV10-r);
{theta,stderr,Mcov,Logl} = ml_eds(R0,&Mu,&Sigma,0,k,sv,RR,r);
estim[.,8] = theta;
g = 1;
call test_LR(Logl10,Logl,g);
call test_LM(_ml_derivatives,g,0);
call test_Wald(CC,c,theta10,Mcov10,g);


/* Modele P11 */

CC = 1~0~0~0~0 |
     0~0~1~0~0 |
     0~0~0~0~1 ;
c = 0|1|1;
{RR,r} = Explicit_to_Implicit(CC,c);
sv = invpd(RR'RR)*RR'(SV10-r);
_tsm_Mcov = 3;
{theta,stderr,Mcov,Logl} = ml_eds(R0,&Mu,&Sigma,0,k,sv,RR,r);
_tsm_Mcov = 1;
estim[.,11] = theta;
g = 3;
call test_LR(Logl10,Logl,g);
call test_LM(_ml_derivatives,g,0);
call test_Wald(CC,c,theta10,Mcov10,g);


/* Modele P12 */

CC = 1~0~0~0~0 |
     0~0~1~0~0 ;
c = 0|1;
{RR,r} = Explicit_to_Implicit(CC,c);
sv = invpd(RR'RR)*RR'(SV10-r);
{theta,stderr,Mcov,Logl} = ml_eds(R0,&Mu,&Sigma,0,k,sv,RR,r);
estim[.,12] = theta;
g = 2;
call test_LR(Logl10,Logl,g);
call test_LM(_ml_derivatives,g,0);
call test_Wald(CC,c,theta10,Mcov10,g);


save estim1 = estim;


output off;



/*
**  Rapport de vraisemblance
*/

proc (2) = test_LR(Logl,Loglc,g);
  local LR,pvalue;

  LR = 2*(Logl-loglc); 
  pvalue = cdfchic(LR,g);

  if _print;
    print;
    print "TEST LR";
    print;
    print ftos(g,"Nombre de restrictions : %lf",10,0);
    print ftos(LR,"Statitique LR : %lf",10,5);
    print ftos(pvalue,"P-value: %lf",10,5);
    print;
  endif;

  retp(LR,pvalue);
endp;


/*
**  Multiplicateur de Lagrange 
*/


proc (2) = test_LM(MLderiv,g,cn);
  local Jmatrix,Nobs,ll,beta,resid,R2,LM,pvalue;

  Jmatrix = vread(MLderiv,"J_matrix");
  Jmatrix = packr(Jmatrix);
  Nobs = rows(Jmatrix);
  ll = ones(Nobs,1);

  if cn == 1;
    Jmatrix = Jmatrix[.,1 2 4 5];
  endif;
  beta = ll/Jmatrix;
  resid = ll-Jmatrix*beta;
  R2 = 1 - (resid'resid)/(ll'll);           
  LM = Nobs*R2;                            
  pvalue = cdfchic(LM,g);

  if _print;
    print;
    print "TEST LM";
    print;
    print ftos(g,"Nombre de restrictions : %lf",10,0);
    print ftos(LM,"Statitique LM : %lf",10,5);
    print ftos(pvalue,"P-value: %lf",10,5);
    print;
  endif;

  retp(LM,pvalue);
endp;


/*
**  Test de Wald
*/

proc (2) = test_Wald(CC,c,theta,Mcov,g);
  local W,pvalue;

  W = (CC*theta-c)'*invpd(CC*Mcov*CC')*(CC*theta-c);
  pvalue = cdfchic(W,g);

  if _print;
    print;
    print "TEST de WALD";
    print;
    print ftos(g,"Nombre de restrictions : %lf",10,0);
    print ftos(W,"Statitique de Wald : %lf",10,5);
    print ftos(pvalue,"P-value: %lf",10,5);
    print;  
  endif;

  retp(W,pvalue);
endp;


