new;
library spt,pgraph,tsm,optmum;
TSMset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates_ = NS_frf[.,1];
mu1 = NS_frf[.,2]; mu2 = NS_frf[.,3]; mu3 = NS_frf[.,4]; tau1 = NS_frf[.,5];
R0 = mu1 + mu2;

data = Interpolation_Donnees( calendrier_31jpm(Dates_~R0,19940101,19961231) );
Nobs = rows(data);
Dates_ = data[.,1]; 
R0 = data[.,2]; 

load estim = estim1;
sigma = estim[4,.];
gamma_ = estim[5,.];

diffusion = sigma .* (R0^gamma_);
diffusion = diffusion^2;


indx1 = 1|3|5; 
indx2 = 6|8; 
diffusion1 = diffusion[.,indx1];
diffusion2 = diffusion[.,indx2];

graphset;
  begwind;
  window2(1,2,0,0.75);

  setwind(1);

    _pdate = ""; _ptitlht = 1.75; _pnum = 0; _paxes = 0;
    fonts("simplex simgrma");
    title("Evolution de la fonction de diffusion \202s\201[2]r(t)[2\202g\201]");
    draw;

    graphset;
    _pdate = ""; _pnum = 2; _pysci = 0; _pltype = 6|3|4;
    _pnumht = 0.25; _ptitlht = 0.25; _paxht = 0.25;
    fonts("simplex simgrma complex");
    let xlab = "1994" "1995" "1996" "1997";
    asclabel(xlab,0);
    xtics(1,Nobs,31*12,12);
  

  setwind(2);

    ytics(0.0002,0.0016,0.0004,0);
    _plegstr = "\203P\2011 & \203P\2012\000\203P\2013 & \203P\2014"\
               " & \203P\20111\000\203P\2015";
    _plegctl = {2 6 2 5};
    xy(seqa(1,1,Nobs),diffusion1);

  setwind(3);

    ytics(0.0002,0.0016,0.0004,0);
    _plegstr = "\203P\2016 & \203P\2017"\
               "\000\203P\2018 & \203P\20110 & \203P\20112";
    xy(seqa(1,1,Nobs),diffusion2);

    graphprt("-c=1 -cf=etude2.eps");
  endwind;