new;
library spt,pgraph,tsm,optmum;
TSMset;

cls;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates_ = NS_frf[.,1];
mu1 = NS_frf[.,2]; mu2 = NS_frf[.,3]; mu3 = NS_frf[.,4]; tau1 = NS_frf[.,5];
R0 = mu1 + mu2;

data = Interpolation_Donnees( calendrier_31jpm(Dates_~R0,19940101,19961231) );
Nobs = rows(data);
Dates_ = data[.,1]; R0 = data[.,2];


proc Mu(t,x,theta);
  retp( theta[1] + theta[2]*(x^theta[3]) );
endp;

proc Sigma(t,x,theta);
  retp( theta[4]*(x^theta[5]) );
endp;


proc gradMu(t,x,theta);
  local Nobs;
  Nobs = rows(x);
  retp( ones(Nobs,1)~(x^theta[3])~(theta[2]*ln(x).*(x^theta[3]))~zeros(Nobs,2) );
endp;

proc gradSigma(t,x,theta);
  local Nobs;
  Nobs = rows(x);
  retp( zeros(Nobs,3)~(x^theta[5])~(theta[4]*ln(x).*(x^theta[5])) );
endp;

_eds_gradp = &gradMu|&gradSigma; 
_tsm_parnm = "alpha"|"beta"|"eta"|"sigma"|"gamma";

_print = 0; 
_tsm_Mcov = 0;
__output = 0;

/* Modele P6 */

CC = 0~0~1~0~0 |
     0~0~0~0~1 ;
c = 1|0.5;
{RR,r} = Explicit_to_Implicit(CC,c);

k = 1/365;
rndseed 123;
sv = 0.07|-1.53|1|1.1|1.3;
sv = invpd(RR'RR)*RR'(sv-r);

debut = 41; fin = 991; long = 200;
estim = miss(zeros(Nobs,5),0);

i = debut + long;
do until i > fin - long; 
  y = R0[i-long:i+long];
  {theta,stderr,Mcov,Logl} = ml_eds(y,&Mu,&Sigma,0,k,sv,RR,r);
  sv = invpd(RR'RR)*RR'(theta-r);
  estim[i,.] = theta';
  locate 5,5; print /flush ftos(i,"iteration %lf",2,0);

  i = i + 1;
endo;

save estim2 = estim;

load estim = estim2;

theta = -estim[.,1]./estim[.,2];
kappa = -estim[.,2];
sigma_ = abs(estim[.,4]);

graphset;
  begwind;
  window2(1,2,0,6.855/2);

    _pdate = ""; _pnum = 2; _pnumht = 0.25; _paxht = 0.25; _ptitlht = 0.30;
    let xlab = "1994" "1995" "1996" "1997";
    asclabel(xlab,0);
    xtics(1,Nobs,31*12,12);
    fonts("simplex simgrma");

    setwind(1);
      title("Modele de Cox, Ingersoll et Ross @[1985b@]\Lparametre \202k\201");
      ytics(0,12,4,0);
      xy(seqa(1,1,Nobs),kappa);
    setwind(2);
      title("parametre \202Q\201");
      ytics(0.03,0.07,0.01,0);
      xy(seqa(1,1,Nobs),theta);
    setwind(3);
      title("parametre \202s\201");
      ytics(0.08,0.14,0.02,0);      
      xy(seqa(1,1,Nobs),sigma_);
 
      graphprt("-c=1 -cf=etude5.eps");
    endwind;
