new;
library tsm,optmum,spt,pgraph;
TSMset;

cls;

rndseed 456;

x0 = 0;
a = 0.8;
b = 0.1;
sigma = 0.06;
k = 0.5;

N = 10001;
{t1,x1} = simulation_OU(x0,a,b,sigma,0,5000,N,1);
s = seqa(1,10,1000);
t2 = t1[s];
x2 = x1[s];
x1 = x1[1:1000];

_fourier = 0;    
_smoothing = 10|4|1|0.23; 

{lambda,I1} = PDGM(x1-meanc(x1));
Is1 = Smoothing(I1);
{lambda,I2} = PDGM(x2-meanc(x2));
Is2 = Smoothing(I2);

q = trunc(rows(lambda)/2);


graphset;
  begwind;
  window(2,2,0);
  
  setwind(1);
    _pnum = 2; _pdate = ""; _pnumht = 0.25; _paxht = 0.25; _ptitlht = 0.25;
    _plctrl = -1; _pstype = 1; _psymsiz = 5;
    title("Trajectoire discrete (k = 5)");
    xlabel("t");
    ylabel("x(t)");
    xtics(0,1000,250,0);
    ytics(-0.10,0.30,0.10,0);
    xy(t2,x2);
  setwind(2);
    _plctrl = -1; _pstype = 1; _psymsiz = 1;
    title("Portrait de phase (k = 0.5)");
    xlabel("x(t)");
    ylabel("x(t+1)");
    xtics(-0.10,0.30,0.10,0);
    ytics(-0.10,0.30,0.10,0);
    xy(x1,lagn(x1,-1));
  setwind(3);
    title("Portrait de phase (k = 5)");
    xy(x2,lagn(x2,-1));
  setwind(4);
    graphset;
    _pnum = 2; _pdate = ""; _pnumht = 0.25; _paxht = 0.25; _ptitlht = 0.25;
    fonts("simplex simgrma");
    title("Spectre estime");
    xlabel("frequence");
    xtics(0,pi,pi/4,0);
    ytics(0,0.015,0.005,0);
    _pysci = 0;
    lab = " 0 \202p\201/4 \202p\201/2 \2013\202p\201/4 \202p\201";
    asclabel(lab,0);
    _plegstr = "k = 0.5\000k = 5";
    _plegctl = {2 7 4 3.5};
    xy(lambda[1:q],Is1[1:q]~Is2[1:q]);

    graphprt("-c=1 -cf=ou2.eps");    
  endwind;
