new;
library spt,pgraph;
SPTset;

Msym ".";

declare matrix r0,mu,phi,sigma;

proc procMu(t);
  retp(mu);
endp;

proc procPhi(t);
  retp(phi);
endp;
 
proc procSigma(t);
  retp(sigma);
endp;

mu = 0.10;
phi = 0.7;
sigma = 0.2;
r0 = 0.05;

TT = 3;
N = 30;
delta0 = BKdelta0(r0,&procPhi,&procMu,&procSigma,0,TT,N,0.1,2);
{t,R} = BlackKarasinski(r0,&procPhi,&procMu,&procSigma,0,delta0,N); 

x = t[1];
n = 2;
do until n > rows(t);
  x = x | t[n]*ones(n,1);
  n = n + 1;
endo;

graphset;
  _pdate = ""; _pnum = 2;
  title("Modele de Black et Karasinski");
  _plctrl = -1; _pstype = 8; _psymsiz = 2;
  xlabel("t"); ylabel("r(t)");
  xtics(-1,4,1,10);
  graphprt("-c=1 -cf=bk1.eps");
  xy(x,R);