new;
library spt,pgraph,tsm,optmum;
SPTset;
TSMset;

cls;

F0 = 0.10;
t0 = 1;
t = 2;
sigma1 = 0.02;
sigma2 = 0.05;
c = 0.125;

proc procSigma(theta,T);
  local Nobs;
  Nobs = maxc(rows(theta)|rows(T));
  retp( sigma1*ones(Nobs,1) ~ sigma2.*exp(-c/2.*(T-theta)) );
endp;

TauxZero = HeathJarrowMorton(F0,&procSigma,t0,t,100,2000);

{r,d,F,retcode} = Kernel(TauxZero);

dt = t-t0;
mu1 = F0 + 0.5*(sigma1*dt)^2 
      -2*(sigma2/c)^2*( (1-exp(-c*dt)) - 2*(1-exp(-c/2*dt)) );
mu2 = (sigma1^2)*dt + (sigma2^2)*(1-exp(-c*dt))/c;
dsymb = pdfn((r-mu1)/sqrt(mu2))/sqrt(mu2);


graphset;
  _pdate = ""; _pnum = 2; 
  fonts("simplex simgrma");
  title("Fonction de densite du taux zero r(2)"\
        "\Lf]1[(1) = 10%   "\
        "\202s\201]1[\202\34Q\201,T\202\118\201 = 0.02   "\
        "\202s\201]2[\202\34Q\201,T\202\118\201 = 0.05\202*"\
        "\201exp\202\34\201-0.125/2\202*\34\201T-\202Q\118\118\201");
  _plegstr = "symbolique\000numerique (100 points de discretisation)";
  _plegctl = {2 6 1 1};
  graphprt("-c=1 -cf=hjm2.eps");
  xy(r,dsymb~d);
