new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Dates = NS_frf[.,1];

tau = seqa(1/12,1/12,12);
CZ = NelsonSiegel_CouponZero(NS_frf[.,2:5]',tau);
Nobs = cols(CZ);

indx = 5;
Taux = zeros(Nobs,3);
pi_ = 0.5|0.8|0.5;
delta = 0.99|0.99|0.98;
s = seqa(indx,-1,indx+1);
Binomial = (indx!) ./ ( (s!).*((indx-s)!) );
prob = Binomial .* ( pi_'^s ) .* ( (1-pi_')^(indx-s) );

i = 1;
do until i > Nobs;

	P = ArbreHoLee(CZ[.,i],pi_[1],delta[1]);
    P1 = selectionArbreHoLee(P,1);
    r1 = HoLeeTaux(P1,360,30);
    Taux[i,1] = selectionArbre(r1,indx)'prob[.,1];

	P = ArbreHoLee(CZ[.,i],pi_[2],delta[2]);
    P1 = selectionArbreHoLee(P,1);
    r1 = HoLeeTaux(P1,360,30);
    Taux[i,2] = selectionArbre(r1,indx)'prob[.,2];

	P = ArbreHoLee(CZ[.,i],pi_[3],delta[3]);
    P1 = selectionArbreHoLee(P,1);
    r1 = HoLeeTaux(P1,360,30);
    Taux[i,3] = selectionArbre(r1,indx)'prob[.,3];

    i = i + 1;
endo;


data = dates~taux;
data = Interpolation_Donnees(calendrier_31jpm(Data,19940101,19961231));
taux = data[.,2 3 4];
Nobs = rows(data);


graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|4|3;
  fonts("simplex simgrma");
  title("Evolution de E\202'@[\201r[\202\34\2015\202\118]\202\34\2011\202\118@]\201");
  let xlab = "1994" "1995" "1996" "1997";
  asclabel(xlab,0);
  _plegstr = "\202d\201 = 0.99  \202p\201 = 50%\000"\
             "\202d\201 = 0.99  \202p\201 = 80%\000"\
             "\202d\201 = 0.95  \202p\201 = 50%";
  _plegctl = {2 6 2 1.25};
  xtics(1,Nobs,31*12,12); 
  graphprt("-c=1 -cf=holee3.eps");
  xy(seqa(1,1,Nobs),Taux);

