new;
library spt,pgraph;
SPTset;

cls;

fichier = spt_data_path $+ "NS_frf";
load NSfrf = ^fichier;

Dates = NSfrf[.,1];
NScoeff = NSfrf[.,2 3 4 5];   /* Coefficients de Nelson et Siegel */
Nobs = rows(NScoeff);

tau = 1|2|3;
deltaT = 1;
sigma = 0.01;
a = 0.8;

Taux = miss(zeros(3,Nobs),0);

_print = 0;

i = 1;
do until i > Nobs;

  CouponZero = NelsonSiegel_CouponZero(NScoeff[i,.]',tau);
  x = HullWhite(CouponZero,a,sigma,deltaT);
 
  taux[.,i] = selectionHW(x,2);

  locate 5,5; print /flush ftos(i,"Iteration no %lf",3,0);

  i = i + 1;
endo;

data = Interpolation_Donnees( calendrier_31jpm(Dates~Taux',19940101,19961231) );
Nobs = rows(data);


graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|3|4;
  fonts("simplex simgrma");
  title("Modele de Hull et White");
  let xlab = "1994" "1995" "1996" "1997";
  asclabel(xlab,0);
  xtics(1,Nobs,31*12,12);
  _plegstr = "r(2,1)\000r(2,0)\000r(2,-1)";
  _plegctl = {2 6 6 4.5};
  ytics(0.04,0.11,0.01,2);
  graphprt("-c=1 -cf=hw1.eps");
  xy(seqa(1,1,Nobs),data[.,2 3 4]);


