new;
library spt,pgraph;
SPTset;

fichier = spt_data_path $+ "NS_dem"; load NS_dem = ^fichier;
Date_dem = NS_dem[.,1];

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;
Date_frf = NS_frf[.,1];

fichier = spt_data_path $+ "change"; data = loadd(fichier);
Date_S = data[.,1];
S0 = data[.,2]/100;

Dates = intrsect(Date_dem,Date_frf,1);
Dates = intrsect(Dates,Date_S,1);
Nobs = rows(Dates);

indx_dem = zeros(Nobs,1);
indx_frf = zeros(Nobs,1);
indx_S = zeros(Nobs,1);

i = 1; 
do until i > Nobs;

  indx = indexcat(Date_dem,Dates[i]);

  if indx /= error(13);
    indx_dem[i] = indx;
  endif;

  indx = indexcat(Date_frf,Dates[i]);

  if indx /= error(13);
    indx_frf[i] = indx;
  endif;

  indx = indexcat(Date_S,Dates[i]);

  if indx /= error(13);
    indx_S[i] = indx;
  endif;

  i = i + 1;
endo;

NS_dem = NS_dem[indx_dem,.];
NS_frf = NS_frf[indx_frf,.];
S0 = S0[indx_S,.];

mu1 = NS_frf[.,2]; mu2 = NS_frf[.,3]; r = mu1 + mu2;

mu1 = NS_dem[.,2]; mu2 = NS_dem[.,3]; rstar = mu1 + mu2;

e = ones(Nobs,1);
K = 3.40; 
tau = seqa(30/365,2.5/365,26); 
sigma = 0.09; 

P = exp(-r.*tau');
Pstar = exp(-rstar.*tau');
C1 = 60000*callGarmanKohlhagen(S0,K,sigma,tau',P,Pstar)./S0;

P = NelsonSiegel_CouponZero(NS_frf[.,2:5]',tau)';
Pstar = NelsonSiegel_CouponZero(NS_dem[.,2:5]',tau)';
C2 = 60000*callGarmanKohlhagen(S0,K,sigma,tau',P,Pstar)./S0;

data = Dates~(C1-C2);
data = Interpolation_Donnees(calendrier_31jpm(Data,19950101,19951231));
dC = packr(data[.,2:cols(data)]);
Nobs = rows(dC);


graphset;
  _pdate = ""; _pnum = {2,2,2}; _paxht = 0.25; _pnumht = 0.20;
  let ylab = "1994" "1995" "1996" "1997";
  ylabel("1995");
  asclabel(ylab,0);
  ytics(0,12,1,0);
  ztics(-20,60,20,0);
  xlabel("Maturite de l'option");
  title("Difference entre\L"\
        "le prix du contrat calcule a partir des taux zero instantanes"\
        "\Let le prix du contrat calcule a partir des coupons zero");
  graphprt("-c=1 -cf=option1.eps");
  surface(365*tau',12*seqa(1,1,Nobs)/Nobs,dC);
