new;
library spt,pgraph,tsm,optmum;
TSMset;

fichier = spt_data_path $+ "NS_frf"; load NS_frf = ^fichier;

Nobs = rows(Ns_frf);
Dates = NS_frf[.,1];

mu1 = NS_frf[.,2]; mu2 = NS_frf[.,3]; r0 = mu1 + mu2;

tau = seqa(0.25,0.25,4);

pCZ0 = exp(-r0'.*tau);
F0 = FonctionActualisation(pCZ0);
pCZ1 = NelsonSiegel_CouponZero(NS_frf[.,2:5]',tau);
F1 = FonctionActualisation(pCZ1);

C = zeros(Nobs,2);

i = 1;
do until i > Nobs;
  C[i,1] = amFutureCRR(100,98,0.05,1,F0[.,i],4);
  C[i,2] = amFutureCRR(100,98,0.05,1,F1[.,i],4);
  i = i + 1;
endo;

tau = seqa(1,1,4);

pCZ0 = exp(-r0'.*tau);
F0 = FonctionActualisation(pCZ0);
pCZ1 = NelsonSiegel_CouponZero(NS_frf[.,2:5]',tau);
F1 = FonctionActualisation(pCZ1);

C_ = zeros(Nobs,2);

i = 1;
do until i > Nobs;
  C_[i,1] = amFutureCRR(100,98,0.05,4,F0[.,i],4);
  C_[i,2] = amFutureCRR(100,98,0.05,4,F1[.,i],4);
  i = i + 1;
endo;

data = Dates~C~C_;
data = Interpolation_Donnees(calendrier_31jpm(Data,19940101,19961231));
Nobs = rows(data);


graphset;
  begwind;
  window2(1,2,0,1.25);

    setwind(1);

      _pdate = ""; _pnum = 0; _paxes = 0; _ptitlht = 1.;
      fonts("simplex simgrma");
      title("Prime d'une option americaine sur future\L"\
            "F]0[ = 100  K = 98  \202s\201 = 5%\Lmodele de CRR avec 4 arbitrages");
      draw;

    graphset;
    _pdate = ""; _pnum = 2; _ptitlht = 0.30; _paxht = 0.30; _pnumht = 0.30;
    let xlab = "1994" "1995" "1996" "1997";
    asclabel(xlab,0);
    xtics(1,Nobs,31*12,12);
    fonts("simplex simgrma");

    setwind(2);
      _pltype = 6|4;
      title("maturite 1 an");
      ytics(3.050,3.175,0.025,0);
      _plegstr = "Modele I\000Modele II";
      _plegctl = {2 6 7.5 1};
      xy(seqa(1,1,Nobs),data[.,2 3]);

    setwind(3);

      title("maturite 4 ans");
      ytics(4.1,4.6,0.1,0);
      _plegctl = {2 6 -1.5 1};
      graphprt("-c=1 -cf=option3.eps");
      xy(seqa(1,1,Nobs),data[.,4 5]);

  endwind;
