new;
library spt,optmum,pgraph;
SPTset;

cls;

declare matrix TauxZero; 
declare matrix r0fixe;   
declare matrix tau;

fichier = spt_data_path $+ "NS_frf";
load NSfrf = ^fichier;

Dates = NSfrf[.,1];
NScoeff = NSfrf[.,2 3 4 5];
Nobs = rows(NScoeff);


tauMax = 10;
N = 121;
t = seqa(0,10/120,121);

proc (14) = BDFScoefficients(theta);
  local r0,theta0,v0,
        kappaR,kappaTheta,kappaV,thetaBar,vBar,sigmaTheta,sigmaV,rho,
        lambdaR,lambdaTheta,lambdaV;

  theta = theta^2 + 0.0001;

  kappaR = theta[1]; 
  kappaTheta = 1;
  kappaV = 0;

  thetaBar = theta[2];   
  vBar = 0;  

  sigmaTheta = theta[3];
  sigmaV = 0;

  rho = 0;
  lambdaR = 0;  
  lambdaTheta = 0;    
  lambdaV = 0;

  r0 = r0fixe;
  theta0 = theta[4]; 
  V0 = theta[5]; 

  retp(r0,theta0,v0,
       kappaR,kappaTheta,kappaV,thetaBar,vBar,sigmaTheta,sigmaV,rho,
       lambdaR,lambdaTheta,lambdaV);
endp;


proc FonctionCritere(theta);
  local r0,theta0,v0,
        kappaR,kappaTheta,kappaV,thetaBar,vBar,sigmaTheta,sigmaV,rho,
        lambdaR,lambdaTheta,lambdaV;

  local CZtheorique,TZtheorique,scr;

  {r0,theta0,v0,
   kappaR,kappaTheta,kappaV,thetaBar,vBar,sigmaTheta,sigmaV,rho,
   lambdaR,lambdaTheta,lambdaV} = BDFScoefficients(theta);


  {tau,CZtheorique,TZtheorique} = BDFS(r0,theta0,v0,
              kappaR,kappaTheta,kappaV,thetaBar,vBar,sigmaTheta,sigmaV,rho,
              lambdaR,lambdaTheta,lambdaV,tauMax,N);


  scr = sumc( (packr(TauxZero-TZtheorique))^2 );

  retp(scr);
endp;

BDFScoeff = zeros(Nobs,14);  

let sv =      1    
              0.065  0.005
              0.05  0.006;

sv = sqrt(sv);

__output = 0;
_opgtol = 0.0001;

i = 1;
do until i > Nobs;

  TauxZero = NelsonSiegel_TauxZero(NScoeff[i,.]',t);
  r0fixe = NScoeff[i,1] + NScoeff[i,2];
  {theta,f,g,retcode} = optmum(&FonctionCritere,sv);
  sv = theta;

  {r0,theta0,v0,
   kappaR,kappaTheta,kappaV,thetaBar,vBar,sigmaTheta,sigmaV,rho,
   lambdaR,lambdaTheta,lambdaV} = BDFScoefficients(theta);

  BDFScoeff[i,.] =   r0~theta0~v0~
                   kappaR~kappaTheta~kappaV~thetaBar~vBar~sigmaTheta~sigmaV~rho~
                   lambdaR~lambdaTheta~lambdaV;

  locate 5,5; print /flush ftos(i,"Iteration no %lf",3,0);

  i = i + 1;
endo;

save bdfs = BDFScoeff;


load BDFScoeff = bdfs;
data = BDFScoeff[.,1 2 3 4 7 9];

data = Interpolation_Donnees( calendrier_31jpm(dates~data,19940101,19961231) );
Nobs = rows(data);
data = data[.,2:7];


graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|4; _ptitlht = 0.18;
  title("Evolution du coefficient implicite \202Q\201]0[");
  fonts("simplex simgrma");
  let xlab = "1994" "1995" "1996" "1997";
  asclabel(xlab,0);
  _plegstr = "r]0[\000\202Q\201]0[";
  _plegctl = {2 8 6.5 4};
  xtics(1,Nobs,31*12,12);
  ytics(0.01,0.11,0.01,0);
  graphprt("-c=1 -cf=bdfs1.eps");
  xy(seqa(1,1,Nobs),data[.,1 2]);


graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|4; _ptitlht = 0.18;
  title("Evolution du coefficient implicite \202k\201]r[");
  fonts("simplex simgrma");
  let xlab = "1994" "1995" "1996" "1997";
  asclabel(xlab,0);
  xtics(1,Nobs,31*12,12);
  ytics(0.4,1.2,0.2,2);
  graphprt("-c=1 -cf=bdfs2.eps");
  xy(seqa(1,1,Nobs),data[.,4]);
