new;
library spt,optmum,pgraph;
SPTset;

cls;

declare matrix TauxZero; 
declare matrix r0fixe;   

fichier = spt_data_path $+ "NS_frf";
load NSfrf = ^fichier;

Dates = NSfrf[.,1];
NScoeff = NSfrf[.,2 3 4 5];
Nobs = rows(NScoeff);

tau = seqa(1/12,1/12,60)|seqa(6,1,25);

proc (9) = LScoefficients(theta);
  local r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda;

  theta = theta^2 + 0.0001;

  r0 = r0fixe;
  V0 = theta[1];
  alpha = theta[2];
  beta = theta[3];
  gamma_ = theta[4];
  delta = theta[5];
  eta = theta[6];
  xi = theta[7];        
  lambda = 0;           /* lambda = 0 ---> nu = xi + lambda = xi */

  retp(r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda);
endp;


proc FonctionCritere(theta);
  local r0,v0,alpha,beta,gamma_,delta,eta,xi,lambda;
  local CZtheorique,TZtheorique,scr;

  {r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda} = LScoefficients(theta);

  {CZtheorique,TZtheorique} =
        LongstaffSchwartz(r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda,tau);

  scr = sumc( (TauxZero-TZtheorique)^2 );
  retp(scr);
endp;

LScoeff = zeros(Nobs,7);  

let sv =      0.040419483  0.052139366  0.92955634 
              0.29047384   0.17101326   0.012475784  0.65761552;

__output = 0;

i = 1;
do until i > Nobs;

  TauxZero = NelsonSiegel_TauxZero(NScoeff[i,.]',tau);
  r0fixe = NScoeff[i,1] + NScoeff[i,2];
  {theta,f,g,retcode} = optmum(&FonctionCritere,sv);
  sv = theta;

  LScoeff[i,.] = (theta^2 + 0.0001)';
  locate 5,5; print /flush ftos(i,"Iteration no %lf",3,0);

  i = i + 1;
endo;

save LS0 = LScoeff;
