new;
library spt,optmum,pgraph;
SPTset;

cls;

declare matrix TauxZero; 
declare matrix r0fixe;   

fichier = spt_data_path $+ "NS_frf";
load NSfrf = ^fichier;

Dates = NSfrf[.,1];
NScoeff = NSfrf[.,2 3 4 5];   
Nobs = rows(NScoeff);

tau = seqa(1/12,1/12,60)|seqa(6,1,25);

proc (9) = LScoefficients(theta);
  local r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda;
  local x,y,z;

  theta = theta^2 + 0.0001;

  r0 = r0fixe;

  y = theta[1]; 
  z = theta[2];
  x = y/r0 + z;

  alpha = theta[3];
  V0 = y + alpha*r0;
  beta = alpha + x;

  gamma_ = theta[4];
  delta = theta[5];
  eta = theta[6];
  xi = theta[7];        
  lambda = 0;           /* lambda = 0 ---> nu = xi + lambda = xi */

  retp(r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda);
endp;


proc FonctionCritere(theta);
  local r0,v0,alpha,beta,gamma_,delta,eta,xi,lambda;
  local CZtheorique,TZtheorique,scr;

  {r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda} = LScoefficients(theta);

  {CZtheorique,TZtheorique} =
        LongstaffSchwartz(r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda,tau);

  scr = sumc( (TauxZero-TZtheorique)^2 );
  retp(scr);
endp;


LScoeff = zeros(Nobs,9); 

let sv =  0.0059570436   0.21816127  0.20307759 
      0.74514729  0.94198174  -0.31309749  -0.0058336165 ;

__output = 0;

i = 1;
do until i > Nobs;

  TauxZero = NelsonSiegel_TauxZero(NScoeff[i,.]',tau);
  r0fixe = NScoeff[i,1] + NScoeff[i,2];
  {theta,f,g,retcode} = optmum(&FonctionCritere,sv);
  sv = theta;

  {r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda} = LScoefficients(theta);
  LScoeff[i,.] = r0~V0~alpha~beta~gamma_~delta~eta~xi~lambda;
  locate 5,5; print /flush ftos(i,"Iteration no %lf",3,0);

  i = i + 1;
endo;

save LS1 = LScoeff;
