@<------------------- hjm1.prg ------------------->@

new;
library spt;
SPTset;

sigma1 = 0.02;
sigma2 = 0.05;
c = 0.125;

proc procSigma(theta,T);
  local Nobs;
  Nobs = maxc(rows(theta)|rows(T));
  retp( sigma1*ones(Nobs,1) ~ sigma2.*exp(-c/2.*(T-theta)) );
endp;

proc Solution(t0,t);
  local dt,sol1,sol2;
  dt = t - t0;
  sol1 = 0.5*(sigma1*dt)^2;
  sol2 = -2*(sigma2/c)^2*( (1-exp(-c*dt)) - 2*(1-exp(-c/2*dt)) );
  retp(sol1 ~ sol2);
endp;

output file = hjm1.out reset;

t = 20;
print Solution(1,t); print;
print intsimpHJM(&procSigma,1,t,5);
print intsimpHJM(&procSigma,1,t,10);
print intsimpHJM(&procSigma,1,t,25);
print intsimpHJM(&procSigma,1,t,24);
print intsimpHJM(&procSigma,1,t,50);

output off;