@<------------------- bdfs.prg ------------------->@

new;
library spt,pgraph;
SPTset;

kappaR = 0.25; 
kappaTheta = 0.76;     thetaBar = 0.12;    sigmaTheta = 0.02;
kappaV = 0.29;         vBar = 0.00007;     sigmaV = 0.003;
rho = -0.12;
lambdaR = -0.1;        lambdaTheta = 0;    lambdaV = 0;

r0 = 0.06; theta0 = 0.08; V0 = 0.0008; 

tauMax = 30;
N = 300;

x = seqa(0.10,-0.02,5)';

{tau,CouponZero,TauxZero1} = BDFS(x,theta0,v0,
              kappaR,kappaTheta,kappaV,thetaBar,vBar,sigmaTheta,sigmaV,rho,
              lambdaR,lambdaTheta,lambdaV,tauMax,N);

x = seqa(0.10,-0.02,5)';

{tau,CouponZero,TauxZero2} = BDFS(r0,x,v0,
              kappaR,kappaTheta,kappaV,thetaBar,vBar,sigmaTheta,sigmaV,rho,
              lambdaR,lambdaTheta,lambdaV,tauMax,N);

x = seqa(0.0042,0.0042,5)';

{tau,CouponZero,TauxZero3} = BDFS(r0,theta0,x,
              kappaR,kappaTheta,kappaV,thetaBar,vBar,sigmaTheta,sigmaV,rho,
              lambdaR,lambdaTheta,lambdaV,tauMax,N);


graphset;
  begwind;
  window(2,2,2);   

  setwind(1);

    _pdate = ""; _pnum = 0; _paxes = 0; 
    fonts("simplex simgrma complex microb");
    _pmsgstr = "\203Modele de Balduzzi, Das,\000"\
                   "Foresi et Sundaram @[1996@]\000"\
                   "Reproduction des figures\000"\
                   "des pages 46 et 47";
           
    _pmsgctl = 
               0.05~0.75~0.3~0~1~7~0 |
               0.05~0.6~0.3~0~1~7~0 |
               0.05~0.35~0.3~0~1~7~0 |
               0.05~0.2~0.3~0~1~7~0 ;            
    draw;


  graphset;

  fonts("simplex simgrma"); 
  _pnum = 2; _pnumht = 0.25; _ptitlht = 0.25; _paxht = 0.25; _pltype = 6|1|3|4|5;
  xlabel("\202t\201"); ylabel("R(\202t\201)");
  xtics(0,30,5,0);

  setwind(2);
    title("EXHIBIT 1\LYield curves for decreasing r (top-down)");
    xy(tau,TauxZero1);

  setwind(3);
    title("EXHIBIT 2\LYield curves for decreasing \202Q\201 (top-down)");
    xy(tau,TauxZero2);

  setwind(4);
    title("EXHIBIT 3\LYield curves for increasing V (top-down)");
    xy(tau,TauxZero3);

    graphprt("-c=1 -cf=_bdfs.eps");

  endwind;  