@<------------------- ml3.prg ------------------->@

new;
library spt,tsm,optmum;
SPTset;
TSMset;

rndseed 123;
a = 0.9; b = 8; sigma = 0.75;
{t,x} = simulation_OU(9,a,b,sigma,0,10,1000,1);


proc procMu(t,x,theta);
  retp(theta[1]*(theta[2]-x));
endp;

proc gradMu(t,x,theta);
  local Nobs;
  Nobs = rows(x);
  retp( (theta[2]-x) ~ ((theta[1]~0).*ones(Nobs,1)) );
endp;

proc procSigma(t,x,theta);
  retp(theta[3]);
endp;

proc gradSigma(t,x,theta);
  retp((0~0~1));
endp;

_eds_gradp = &gradMu|&gradSigma;  /* Jacobien analytique */

k = 10/1000;

sv = a|b|sigma;
CC = 0~1~0; c = 8;
{RR,r} = Explicit_to_Implicit(CC,c);
sv = invpd(RR'RR)*RR'(sv-r);

output file = ml3.out reset;

{theta,stderr,Mcov,Logl} = ml_eds(x,&procMu,&procSigma,0,k,sv,RR,r);

output off;
