@<------------------- simul5.prg ------------------->@

new;
library spt,pgraph;
SPTset;

rndseed 456; 

proc procMu(t,x);
  local mu;

  mu  = 5 - x[1]            |
        t * (x[1] + x[2])   ;

  retp(mu);
endp;

proc procSIGMA(t,x);
  local sigma;

  sigma =  0.75*x[1] ~      0     ~       0                 |
           x[1]   ~    x[2]    ~  sqrt((x[1]^2+x[2]^2))    ;

  retp(sigma);
endp;

X0 = 1|4;
let rho[3,3] =   1   0.25   0
                 0   1     -0.10
                 0  -0.10   1;

{t,x} = simulation_EDSm(X0,&procMu,&procSigma,rho,0,1,500);


graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|3;
  title("Trajectoire d'un processus stochastique multidimensionnel");
  xlabel("t");
  _plegstr = "x]1[(t)\000x]2[(t)";
  _plegctl = {2 7 1.8 4.8};
  graphprt("-c=1 -cf=_simul5.eps");
  xy(t,x);