@<------------------- simul6.prg ------------------->@

new;
library spt,pgraph;
SPTset;

rndseed 456; 

declare matrix kappa_r,kappa_theta,kappa_v;
declare matrix thetaB,vB;
declare matrix sigma_theta,sigma_v;
declare matrix rho12,rho13;

proc procMu(t,x);
  local mu;

  mu  = kappa_r * (x[2] - x[1])         |
        kappa_theta * (thetaB - x[2])   |
        kappa_v * (vB - x[3])           ;

  retp(mu);
endp;

proc procSIGMA(t,x);
  local sigma;

  sigma =  sqrt(x[1])*sqrt(x[3])  ~  0  ~  0  |
           0  ~  sigma_theta*sqrt(x[2])  ~  0 |
           0  ~  0  ~ sigma_v*sqrt(x[3])      ;

  retp(sigma);
endp;


kappa_r = 1;
kappa_theta = 0.8;
kappa_v = 0.5;
thetaB = 0.12;
thetaV = 0.05;
sigma_theta = 0.10;
sigma_v = 0.08;
rho12 = 0.25;
rho13 = 0.5;

rho =   1 ~ rho12 ~ rho13  |
        rho12 ~ 1 ~ 0      |
        rho13 ~ 0 ~ 1      ;

X0 = 0.15|0.07|0.06;
{t,x} = simulation_EDSm(X0,&procMu,&procSigma,rho,0,2,1000);

graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|3;
  fonts("simplex simgrma");
  title("Trajectoire du processus stochastique de CHEN @[1995@]");
  xlabel("t");
  _plegstr = "\201r(t)\000\202Q\201(t)\000v(t)";
  _plegctl = {2 7 6 4.2};
  graphprt("-c=1 -cf=_simul6.eps");
  xy(t,x);