@<------------------- spt1.prg ------------------->@

new;
library spt,pgraph;
SPTset;

kappa = 0.8; theta = 0.10; sigma = 0.5; lambda = 0.05;

proc procMu(x);
  retp(kappa*(theta-x));
endp;

proc procSigma(x);
  retp(sigma*sqrt(x));
endp;

proc procLambda(x);  
  retp(lambda*sqrt(x)/sigma);
endp;

proc procR(x);
  retp(x);
endp;

t0 = 0;
T = 5;
call SPT(&procMu,&procSigma,&procLambda,&procR,t0,T,0);

_spt_algorithme = 0;
_print = 0;

{t,x,k,h} = solution_EDP(0,1,101,501,0.5,"spt1");
tau1 = 5 - t;

r0 = x[51];
U1 = Lire_EDP("spt1","x"|r0);
U1 = -ln(U1)./miss(tau1,0);
{CZ1,TZ1} = CIR(r0,kappa,theta,sigma,lambda,tau1);

t0 = t[251];
tau2 = 5 - t0;
U2 = Lire_EDP("spt1","t"|t0);
U2 = -ln(U2)/tau2;
{CZ2,TZ2} = CIR(x,kappa,theta,sigma,lambda,tau2);


graphset;
  _pdate = ""; _pnum = 2;
  fonts("simplex simgrma");
  title("Solution numerique du modele de Cox, Ingersoll et Ross @[1985@]"\
        "\Lmethode des \202Q\201-schemas");
  _plegstr = "solution analytique\000solution numerique";
  _plegctl = {2 6 5 3};
  xlabel("\202t\201");
  ylabel("R]t[(\202t\201)");
  graphprt("-c=1 -cf=_spt1a.eps");
  xy(tau1,TZ1~U1);

  xlabel("r]0[");
  str = "R]t[(" $+ ftos(t0,"%lf",4,3) $+ ")" ;
  ylabel(str);
  graphprt("-c=1 -cf=_spt1b.eps");
  xy(x,TZ2~U2);


