@<------------------- spt3.prg ------------------->@

new;
library spt,pgraph;
SPTset;

kappa = 0.8; theta = 0.10; sigma = 0.5; lambda = 0.05;

proc procMu(t,x);
  x = x .* (x .> 0);
  retp(kappa*(theta-x));
endp;

proc procSigma(t,x);
  x = x .* (x .> 0);
  retp(sigma*sqrt(x));
endp;

proc procLambda(t,x);  
  x = x .* (x .> 0);
  retp(lambda*sqrt(x)/sigma);
endp;

proc procR(t,x);
  retp(x);
endp;

t0 = 0;
T = 2;
call SPT(&procMu,&procSigma,&procLambda,&procR,t0,T,1);

r0 = 0.20;

_mc_acceleration = 1;

{tau,CouponZero,TauxZero} = mc_SPT(r0,200,100|5);
{CZ,TZ} = CIR(r0,kappa,theta,sigma,lambda,tau);


graphset;
  _pdate = ""; _pnum = 2;
  fonts("simplex simgrma");
  title("Solution numerique du modele CIR"\
        "\Lmethode de Monte Carlo");
  xlabel("\202t\201");
  ylabel("erreur");
  graphprt("-c=1 -cf=_spt3.eps");
  xy(tau,TZ-TauxZero);
