@<------------------- spt4.prg ------------------->@

new;
library spt,pgraph;
SPTset;

declare matrix kappa_r,kappa_theta,kappa_v;
declare matrix thetaB,vB;
declare matrix sigma_theta,sigma_v;
declare matrix rho12,rho13;
declare matrix lambda_r,lambda_theta,lambda_v;

proc procMu(t,x);
  local mu;
  x = x .* (x .> 0);
  mu  = kappa_r * (x[2] - x[1])         |
        kappa_theta * (thetaB - x[2])   |
        kappa_v * (vB - x[3])           ;

  retp(mu);
endp;

proc procSIGMA(t,x);
  local sigma;
  x = x .* (x .> 0);
  sigma =  sqrt(x[1])*sqrt(x[3])  ~  0  ~  0  |
           0  ~  sigma_theta*sqrt(x[2])  ~  0 |
           0  ~  0  ~ sigma_v*sqrt(x[3])      ;

  retp(sigma);
endp;


proc procLambda(t,x);  
  local lambda;
  x = x .* (x .> 0);
  lambda = lambda_r*sqrt(x[1])*sqrt(x[2])      |
           lambda_theta*sqrt(x[2])/sigma_theta |
           lambda_v*sqrt(x[3])/sigma_v ;
  retp(lambda);
endp;

proc procR(t,x);
  retp(x[.,1]);
endp;

kappa_r = 1;
kappa_theta = 0.8;
kappa_v = 0.5;
thetaB = 0.12;
thetaV = 0.05;
sigma_theta = 0.10;
sigma_v = 0.08;
rho12 = 0.25;
rho13 = 0.5;
lambda_r = 0.03;
lambda_theta = 0.01;
lambda_v = 0.02;


rho =   1 ~ rho12 ~ rho13  |
        rho12 ~ 1 ~ 0      |
        rho13 ~ 0 ~ 1      ;

t0 = 0;
T = 10;
call SPTm(&procMu,&procSigma,rho,&procLambda,&procR,t0,T,1);

X0 = 0.15|0.07|0.06;

_mc_acceleration = 1;

{tau,CouponZero,TauxZero} = mc_SPTm(X0,1000,100);

graphset;
  _pdate = ""; _pnum = 2;
  fonts("simplex simgrma");
  title("Solution numerique du modele de CHEN @[1995@]"\
        "\Lmethode de Monte Carlo");
  xlabel("\202t\201");
  ylabel("R]t[(\202t\201)");
  graphprt("-c=1 -cf=_spt4.eps");
  xy(tau,TauxZero);
