@<------------------- svensson.prg ------------------->@

new;
library spt,tsm,optmum,pgraph;
SPTset;
TSMset;

r0 = 0.061448386;  V0 = 0.040419483;  alpha = 0.052139366; 
beta =  0.92955634;  gamma_ = 0.29047384;  delta = 0.17101326; 
eta = 0.012475784;  xi = 0.65761552;  lambda = 1.06184e-005; 

tau = seqa(1/10,1/10,100);
{CouponZeroLS,TauxZeroLS} =
        LongstaffSchwartz(r0,V0,alpha,beta,gamma_,delta,eta,xi,lambda,tau);

obligation = CouponZero_to_Obligation(CouponZeroLS,tau);

CC = 1~1~0~0~0~0 |
     1~0~0~0~0~0 ;
c = 0.06  |
    0.057 ;

/* Estimation contrainte r(0) = 6% et r(infini) = 5.7% */

theta = Svensson(obligation,1,CC,c);

tau = seqa(1/10,1/10,500);

CouponZero = Svensson_CouponZero(theta,tau);
TauxZero = Svensson_TauxZero(theta,tau);
TauxAterme1 = Svensson_TauxATerme(theta,tau,0);
TauxAterme2 = Svensson_TauxATerme(theta,5,tau);

graphset;
  begwind;
  window(2,2,0);

    _pdate = ""; _pnum = 2; _paxht = 0.30; _pnumht = 0.30; _ptitlht = 0.30;
    _pltype = 6|1|3|4; 
    fonts("simplex simgrma");
    xtics(0,50,10,10); xlabel("\202t\201");

  setwind(1);

    title("Coupon zero P[c]]t[(\202t\201)");
    ytics(0.0,1,0.25,0);
    xy(tau,CouponZero);

  setwind(2);

    title("Taux zero R]t[(\202t\201)");
    ytics(0.052,0.062,0.002,0);
    xy(tau,TauxZero);

  setwind(3);

    title("Taux a terme instantane F]t[(\202t\201,0)");
    ytics(0.05,0.07,0.005,0);
    xy(tau,TauxATerme1);

  setwind(4);

    title("Taux a terme (a 5 ans) F]t[(5,\202t\201)");
    ytics(0.055,0.065,0.0025,0);
    xy(tau,TauxATerme2);

    graphprt("-c=1 -cf=_svensso.eps");

  endwind;

